// WebClientConn.cpp: implementation of the CWebClientConn class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EnhydraConn.h"
#include "JavalinIISAdmin.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CJavalinIISAdmin::CJavalinIISAdmin()
{
}

// Check whether the current request is an ISAPI extension "admin" request
// NOTE - parameters are currently hard-coded, eventually the LOGIN and PASSWORD
// parameters will be loaded from the config file, as will a URL prefix identifying the
// request as "admin"
bool CJavalinIISAdmin::isAdminRequest(CHttpServerContext* pCtxt, LPTSTR pszQuery)
{
	CConfig *pConfig = CConfig::getInstance();
	if(NULL != pConfig && NULL != pszQuery) {
		return (0 == stricmp(pszQuery, "REQUEST=StatusPage&LOGIN=flooby&PASSWORD=biteme"));
	}

	return false;
}

// provide processing for an "admin" request
// - currently nly a status page is supported
void CJavalinIISAdmin::Default(CHttpServerContext* pCtxt)
{
	// this gets called if the request is for a status report
	//StartContent(pCtxt);
	//WriteTitle(pCtxt);

	*pCtxt << _T("<H1>Javalin ISAPI Plug-in Status</H1>");

	*pCtxt << _T("<BR><BR> \r\n");
	*pCtxt << _T("<TABLE BORDER=1> \r\n");
	*pCtxt << _T("<TR><TD></TD><TD><B>Host</B></TD><TD><B>Completed Requests</B></TD><TD><B>Completed Requests</B></TD><TD><B>Connections</B></TD><TD><B>Failed Connections</B></TD></TR> \r\n");

	//EnterCriticalSection( &(CConfig::m_csCacheLock) );

	int gtComplete = 0;
	int gtConsecutiveComplete = 0;
	int gtError = 0;
	int gtConsecutiveError = 0;
	double gtAvg = 0;
	double gtConsecutiveAvg = 0;

	JAVALIN_HOST* jHost = CConfig::m_HostNext;
	//CConfig::m_HostNext = CONTAINING_RECORD( CConfig::m_HostNext->ListEntry.Flink, JAVALIN_HOST, ListEntry );

	while (0 != jHost->index)
	{
		jHost = CONTAINING_RECORD( jHost->ListEntry.Flink, JAVALIN_HOST, ListEntry );
	}

	DWORD i;
	for (i=0; i<CConfig::m_cHostCount; i++)
	{
		gtComplete += jHost->totalComplete;
		gtConsecutiveComplete += jHost->consecutiveComplete;
		gtError += jHost->totalError;
		gtConsecutiveError += jHost->consecutiveError;
		gtAvg += jHost->totalTime;
		gtConsecutiveAvg += jHost->consecutiveTime;

		char foo[1024];
		double totalAvg = 0;
		double consecutiveAvg = 0;
		if (0 < jHost->totalComplete)
			totalAvg = (jHost->totalTime / jHost->totalComplete);
		if (0 < jHost->consecutiveComplete)
			consecutiveAvg = (jHost->consecutiveTime / jHost->consecutiveComplete);

		sprintf(foo, "<TR><TD> %d </TD><TD> %s:%d (%d) </TD><TD> %d (%d) %7.3f </TD><TD> %d (%d) %7.3f </TD><TD> %d (%d)</TD><TD> %d (%d)</TD></TR> \r\n",
			jHost->index,
			jHost->achHostName, jHost->port, jHost->weight, 
			jHost->totalComplete, jHost->totalError, totalAvg,
			jHost->consecutiveComplete, jHost->consecutiveError, consecutiveAvg,
			jHost->totalConnect, jHost->activeConnect, jHost->totalFail, jHost->consecutiveFail);

		*pCtxt << _T(foo);

		jHost = CONTAINING_RECORD( jHost->ListEntry.Flink, JAVALIN_HOST, ListEntry );
	}

	//LeaveCriticalSection( &(CConfig::m_csCacheLock) );

	char foo2[1024];
	if (0 < gtComplete)
		gtAvg = gtAvg / gtComplete;
	else
		gtAvg = 0;
	if (0 < gtConsecutiveComplete)
		gtConsecutiveAvg = gtConsecutiveAvg / gtConsecutiveComplete;
	else
		gtConsecutiveAvg = 0;
	sprintf(foo2, "<TR><TD></TD><TD><B>Totals:</B></TD><TD> %d (%d) %7.3f </TD><TD> %d (%d) %7.3f </TD><TD></TD><TD></TD></TR> \r\n",
		gtComplete, gtError, gtAvg,
		gtConsecutiveComplete, gtConsecutiveError, gtConsecutiveAvg);

	*pCtxt << _T(foo2);

	*pCtxt << _T("</TABLE> \r\n");
	*pCtxt << _T("<BR><BR> \r\n");

	//EndContent(pCtxt);
}


