/*-----------------------------------------------------------------------------
 * Enhydra Java Application Server
 * Copyright 1997-1999 Lutris Technologies, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes Enhydra software developed by Lutris
 *      Technologies, Inc. and its contributors.
 * 4. Neither the name of Lutris Technologies nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY LUTRIS TECHNOLOGIES AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL LUTRIS TECHNOLOGIES OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *-----------------------------------------------------------------------------
 * $Id: TagSet.java,v 1.4 1999/02/12 12:17:58 andy Exp $
 *-----------------------------------------------------------------------------
 */



package dods.builder.engine;

import java.util.Hashtable;
import java.util.Enumeration;

public class TagSet {
    private Hashtable    tagValues = new Hashtable();
    private final String sep       = ":";
    private String       dupTest   = sep;

    public TagSet() {}

    public void setTagValue( String tag, String value ) throws Exception {
	String old = (String) tagValues.get( "<" + tag + ">" );
	if ( null != old ) {
/*
      // DBG
	    System.out.println("Tag '" + tag + "' value was '" 
				+ old + "', is now '" + value + "'" );
*/
	} else {

// DBG
// System.err.println("dupTest: <<<<"+dupTest+">>>>");
	    int index = dupTest.indexOf(sep+ tag +sep);
	    if ( index >= 0) {
		int precedingSep = dupTest.lastIndexOf( sep, index );
		int trailingSep  = dupTest.indexOf(     sep, index );
		throw new Exception( "Tag '" + tag + "' conflicts with: "
		    + dupTest.substring( precedingSep + 1, trailingSep ) );
	    }
	    dupTest += sep + tag;
	}
	tagValues.put( "<" + tag + ">", value );
    }

    public String getTagValue( String tag ) throws Exception {
	String value = (String) tagValues.get( tag );
	if ( null == value )	
	    value = (String) tagValues.get( "<" + tag + ">" );
	if ( null == value )	
	    throw new Exception( "No value for tag '" + tag + "'" );
	return value;
    }

    public Enumeration getTags() throws Exception {
	return tagValues.keys();
    }
}
