#!/bin/csh -x
#
# createMakefile.csh
#
#
set rootdir = $1
shift
set pkgdir = $1
shift
set basedir = $1
shift
set extracp = $1
shift

cat << END_DEBUG > /dev/tty

createMakefile.csh
    rootdir = $rootdir
    pkgdir  = $pkgdir
    basedir = $basedir
    extracp = $extracp
END_DEBUG

#echo cd $basedir/$pkgdir > /dev/tty
cd $basedir/$pkgdir

set subdirs = ( ` ls -l | grep ^d | grep -v classes | awk '{print $NF}' ` )

set classes = ( )
set nonomatch
set sources = ( *.java )
if ( $sources[1] == '*.java' ) then
    set classes = ( )
    set sources = () 
    set rm_sources = "echo continuing..."
else
    set classes = ( ` echo $sources | sed 's,\.java,,g' ` )
    set rm_sources = "rm $sources"
endif
unset nonomatch

#echo subdirs=$subdirs > /dev/tty
#echo sources=$sources > /dev/tty
#echo classes=$classes > /dev/tty

cat << END_MAKEFILE >! Makefile

ROOT =		$rootdir

PACKAGEDIR = 	$pkgdir

CLASSES = 	$classes

SUBDIRS = 	$subdirs

XTRA_CLASSPATH = $extracp

include \$(ROOT)/config.mk

delete_source:
	@$rm_sources ; \
        subs="\$(SUBDIRS)" ; \
        if [ -n "\$\$MAKE_PATH" ] ; then \
            PARENT_PATH="\$\$MAKE_PATH" ; \
        else  \
            PARENT_PATH="." ; \
        fi ; \
        export PARENT_PATH ; \
        for d in \$\$subs ; \
            do \
                ( cd \$\$d || exit 1 ; \
                MAKE_PATH="\$\$PARENT_PATH/\$\$d" ; \
                export MAKE_PATH ; \
                echo "<< Start  CLEANUP pass in: \$\$MAKE_PATH >>" > /dev/tty ; \
                \$(MAKE) delete_source || exit 0 ; \
                echo "<< Finish CLEANUP pass in: \$\$MAKE_PATH >>" > /dev/tty ; \
                ) ; \
            done

END_MAKEFILE

exit

# JAY rigging the top level makefile to concatenate all the .table files
# and create a shell script that will use the appropriate db utility
# to run them.

if ( X != X$pkgdir ) exit

# We are generating the top level Makefile

cat << END_MAKEFILE2 >>! Makefile

create_db_script:
	mkdir -p \$(ROOT)/db_scripts; \

END_MAKEFILE2
