#!/bin/sh
#
# createMakefile.sh
#
#

# set DEBUG to /dev/null or /dev/tty
DEBUG=/dev/null
#DEBUG=/tmp/mg.out

script=$0
scriptDir=`echo $script | sed 's,\(/.*/\).*,\1,'`
[ $script = $scriptDir ] && scriptDir=.
 
echo scriptDir=$scriptDir >> $DEBUG
 
rootdir=$1
shift
pkgdir=$1
shift
basedir=$1
shift
extracp=$1
shift

cat << END_DEBUG >> $DEBUG

createMakefile.sh
    rootdir = $rootdir
    pkgdir  = $pkgdir
    basedir = $basedir
    extracp = $extracp
END_DEBUG

pkgdir=`echo $pkgdir | sed "s,$basedir,,"`

echo cd $basedir/$pkgdir >> $DEBUG
cd $basedir/$pkgdir

subdirs=`ls -l | grep '^d' | grep -v classes | awk '{s=s" "$NF}END{print s}'`

#ls *.java >> $DEBUG

classes=
sources=`echo *.java`

echo sources=$sources >> $DEBUG

if [ "$sources" = '*.java' ]; then
    sources=
    rm_sources="echo continuing..."
else
    classes=`echo $sources | sed 's,\.java,,g'`
    rm_sources="rm $sources"
fi

echo subdirs=$subdirs >> $DEBUG
echo sources=$sources >> $DEBUG
echo classes=$classes >> $DEBUG

answer=`$scriptDir/fixMakefiles.sh`
echo answer=$answer >> $DEBUG
[ "$answer" != "" ] && {
    rootdir=`echo $answer | sed 's, .*,,'`
    pkgdir=`echo $answer | sed -e 's,.* ,,' -e 's,\.,/,g' -e 's,;,,'`
    [ "$pkgdir" = "$rootdir" ] && pkgdir=""
    [ "$pkgdir" = no_java ] && pkgdir=""
}

echo rootdir=$rootdir >> $DEBUG
echo pkgdir=$pkgdir >> $DEBUG

[ -f Makefile ] && rm Makefile
[ -f Makefile ] && {
	echo CANNOT REMOVE MAKEFILE
	ls -l `pwd`/Makefile 
	echo ABORTING.
}

#ls -l Makefile >> $DEBUG
#echo boo >> $DEBUG

cat << END_MAKEFILE > Makefile

ROOT =		$rootdir

PACKAGEDIR = 	$pkgdir

CLASSES = 	$classes

SUBDIRS = 	$subdirs

XTRA_CLASSPATH = $extracp

include \$(ROOT)/config.mk

delete_source:
	@$rm_sources ; \\
        subs="\$(SUBDIRS)" ; \\
        if [ -n "\$\$MAKE_PATH" ] ; then \\
            PARENT_PATH="\$\$MAKE_PATH" ; \\
        else  \\
            PARENT_PATH="." ; \\
        fi ; \\
        export PARENT_PATH ; \\
        for d in \$\$subs ; \\
            do \\
                ( cd \$\$d || exit 1 ; \\
                MAKE_PATH="\$\$PARENT_PATH/\$\$d" ; \\
                export MAKE_PATH ; \\
                echo "<< Start  CLEANUP pass in: \$\$MAKE_PATH >>" >> $DEBUG ; \\
                \$(MAKE) delete_source || exit 0 ; \\
                echo "<< Finish CLEANUP pass in: \$\$MAKE_PATH >>" >> $DEBUG ; \\
                ) ; \\
            done

END_MAKEFILE

exit

# TODO
# rigging the top level makefile to concatenate all the .table files
# and create a shell script that will use the appropriate db utility
# to run them.

[ X != X$pkgdir ] && exit

# We are generating the top level Makefile

cat << END_MAKEFILE2 >> Makefile

create_db_script:
	mkdir -p \$(ROOT)/db_scripts; \

END_MAKEFILE2
