#!/bin/csh
#
# makefileGenerator.csh
#
#
set script = $0
set scriptDir = $script:h
if ( $script == $scriptDir ) set scriptDir = .

set run = $1
shift
set cleanup = $1
shift
set basedir = $1
shift
set rootdir = $1
shift
set extracp = $1
shift
set ENHYDRA_DIR = $1
shift

echo ========================== Generating config.mk in $basedir > /dev/tty
cat << END_CONFIG > $basedir/config.mk
#----------------------------------------------------------------------------- 
# config.mk
#  This is the make configuration for the Lutris DemoApp source tree.
#----------------------------------------------------------------------------- 
# Copyright (C) 1997 Lutris Technologies, Inc.            All Rights Reserved.
#----------------------------------------------------------------------------- 

#
# The directory contain the Lutris distribution.
#
ENHYDRA_DIR = $ENHYDRA_DIR
  
include \$(ENHYDRA_DIR)/lib/stdrules.mk

END_CONFIG

echo '' > /dev/tty
echo ========================== Generating Makefiles in $basedir > /dev/tty
cat << END > /dev/tty
makefileGenerator.csh
    run          = $run
    cleanup      = $cleanup
    basedir      = $basedir
    rootdir      = $rootdir
    extracp      = $extracp
    package dirs = $*
END

if ( ! -d $basedir ) then
	echo "ERROR: $script"": $basedir is not a directory." > /dev/tty
	exit 1
endif

switch ( $rootdir )
case /*:
    breaksw
default:
    set rootdir = $basedir/$rootdir
endsw
if ( ! -d $rootdir/classes ) then
    mkdir $rootdir/classes
    #echo "ERROR: $script"": $rootdir/classes is not a directory." > /dev/tty
    #exit 1
endif

# We could just run createMakefile in every directory under $basedir.
# But there might be some directories not created by the Builder,
# and we wouldn't want to create a new Makefile in those.
# So instead of doing a find for directories,
# we use a list of subdirs passed to us.
#echo find $basedir -type d -print > /dev/tty
#find $basedir -type d -print >& /dev/tty

#echo ls -l $scriptDir/createMakefile.csh >& /dev/tty
#ls -l $scriptDir/createMakefile.csh >& /dev/tty

# Create a list of directories.
# We need a Makefile in each directory, whether or not it contains source code.
set paths = ()
foreach a ( $* ) 
    set p = ""
    foreach d ( ` echo $a | sed 's,/, ,g' ` ) 
	set p = $p$d
	echo " $paths " | grep ' '$p' ' > /dev/null
	if ( 0 != $status ) set paths = ( $paths $p )
	set p = $p/
    end
end
#echo paths = $paths > /dev/tty

#echo find $basedir -type d -exec $scriptDir/createMakefile.csh {} \; > /dev/tty
#find $basedir -type d -exec $scriptDir/createMakefile.csh $rootdir {} $basedir $extracp \;

if ( 1 ) then

cd $basedir

$scriptDir/createMakefile.csh $rootdir "" $basedir $extracp

foreach d ( $paths ) 
    if ( ! -d $d ) then
	echo "ERROR: $script"": $basedir/$d is not a directory." > /dev/tty
	exit 1
    else
	$scriptDir/createMakefile.csh $rootdir $d $basedir $extracp
    endif
end

if ( $run == true ) then
    echo '' > /dev/tty
    echo "$script:t running 'make' in $basedir" > /dev/tty
    make >& /dev/tty
endif

if ( $cleanup == true ) then
    echo '' > /dev/tty
    echo "$script:t running 'make delete_source' in $basedir" > /dev/tty
    make delete_source >& /dev/tty
endif

endif # if(0)
