#!/bin/csh
#
# showTemplateTags.csh
#
if ( "-s" == "$1" ) then
	set summarize
	shift
endif
set files = ()
set bad_files = ()
foreach a ( $* )
	if ( -d $a ) then
		set files = ( $files ` find $a -name '*.template' -print ` )
	else 
		if ( template != "$a:e" ) then
			set bad_files = ( $bad_files $a )
		else
		   set files = ( $files $a )
	   endif
	endif
end
if ( 0 != $#bad_files ) then
	echo Non-template files not scanned:
	echo $bad_files | tr ' ' '\012'
	echo ''
endif

set tags = ()
foreach f ( $files )
	set tags = ( $tags ` tr < $f '<>' '\012' | grep -v '[a-z]' | sed -e 's,^[^<][^<]*<, ,' -e 's,>[^<][^<]*<, ,g' -e 's,>[^<][^<]*$, ,g' -e 's,>$,,' -e 's,[^A-Z_ ][^A-Z_ ]*,,g' ` )
end
set tags = ( ` echo $tags | tr ' ' '\012' | sort | uniq ` )
set generic_tags = ()
set module_tags = ()
foreach t ( $tags )
	grep '"'$t'"' $qdbs/SourceGenerator.java > /dev/null
	if ( 0 == $status ) then
		set generic_tags = ( $generic_tags $t )
	else
		set module_tags = ( $module_tags $t )
	endif
end
echo Generic Tags:
echo ''
echo $generic_tags | tr ' ' '\012'
echo ''
echo Nongeneric Tags:
echo ''
echo $module_tags | tr ' ' '\012' 
