/*-----------------------------------------------------------------------------
 * Enhydra Java Application Server
 * Copyright 1997-1999 Lutris Technologies, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes Enhydra software developed by Lutris
 *      Technologies, Inc. and its contributors.
 * 4. Neither the name of Lutris Technologies nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY LUTRIS TECHNOLOGIES AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL LUTRIS TECHNOLOGIES OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *-----------------------------------------------------------------------------
 * $Id: MySqlObjectIdAllocator.java,v 1.5 1999/02/12 12:26:20 andy Exp $
 *-----------------------------------------------------------------------------
 */





package	com.lutris.appserver.server.sql.mysql;

import com.lutris.appserver.server.sql.standard.*;
import com.lutris.appserver.server.sql.*;
import com.lutris.appserver.server.LBS;
import com.lutris.logging.*;
import com.lutris.util.*;
import java.util.Hashtable;
import java.math.BigDecimal;
import java.sql.*;


/**
 * An MySql database object id allocator used by the Oracle logical
 * database.
 * 
 * @see		StandardObjectIdAllocator
 * @author	Paul Morgan
 * @since	LBS1.8
 * @version	$Revision: 1.5 $
 */
public class MySqlObjectIdAllocator extends StandardObjectIdAllocator {

    /**
     * Initialize the object id manager.
     *
     * @see StandardObjectIdAllocator#StandardObjectIdAllocator
     * @param logicalDatabase
     *   The logical database that this object id allocator is associated
     *   with.
     * @param objIdConfig
     *   The configuration object.
     * @exception ConfigException
     *   if bad configuration information is given in the config file.
     */
    protected MySqlObjectIdAllocator (LogicalDatabase logicalDatabase,
                                       Config objIdConfig)
	throws ConfigException
    {
        super(logicalDatabase, objIdConfig);
    }
}











