import java.io.File;
import org.enhydra.xml.binding.Marshaller;
import org.enhydra.xml.binding.Unmarshaller;

public class TestMapper {

    public static void main(String[] args) {
        System.out.println("Starting unmarshalling...");
        try {
            System.out.println("\n\n......... Start of Unmarshaller test ............\n\n");

            File file = new File("xml/example.xml");
            Object o = Unmarshaller.unmarshall(file.toURL());
            System.out.println("Object class: " + o.getClass().getName());   

            System.out.println("Casting to WebServiceConfiguration...");
            WebServiceConfiguration config = (WebServiceConfiguration)o;
            System.out.println("Successful cast.");

            System.out.println("Name: " + config.getName()); 
            System.out.println("Version: " + config.getVersion());

            System.out.println("Port Number: " + config.getPort().getNumber());
            System.out.println("Port Protocol: " + config.getPort().getProtocol());

            System.out.println("\n\n......... End of Unmarshaller test ............\n");
            System.out.println("\n\n......... Start of Marshaller test ............\n\n");

            Marshaller.marshall(o, System.out);

            System.out.println("\n\n......... End of Unmarshaller test ............\n");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}