/*-----------------------------------------------------------------------------
 * Enhydra Java Application Server
 * Copyright 1997-1999 Lutris Technologies, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes Enhydra software developed by Lutris
 *      Technologies, Inc. and its contributors.
 * 4. Neither the name of Lutris Technologies nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY LUTRIS TECHNOLOGIES AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL LUTRIS TECHNOLOGIES OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *-----------------------------------------------------------------------------
 * $Id: FileSystem.java,v 1.2 1999/02/12 12:18:07 andy Exp $
 *-----------------------------------------------------------------------------
 */

package dods.gui;

import java.io.File;

public class FileSystem {
    // If successful, rmdir returns null.
    // Otherwise, rmdir returns the name of the file or directory
    // that could not be deleted.
    public static String rmdir( File dir ) {
	String ret = null;
	File[] contents = list( dir );
	for ( int i = 0; i < contents.length; i++ ) {
	    if ( contents[ i ].isDirectory() ) {
		if ( null != ( ret = rmdir( contents[ i ] ) ) )
		    return ret;
	    } else {
		if ( ! contents[ i ].delete() )
		    return contents[ i ].getAbsolutePath();
	    }
	}
	if ( ! dir.delete() )
	    ret = dir.getAbsolutePath();
	return ret;
    }

    public static File[] list( File dir ) {
	String[] names = dir.list();
	File[] ret = new File[ names.length ];
	for ( int i = 0; i < names.length; i++ ) {
	    ret[ i ] = new File( dir, names[ i ] );
	}
	return ret;
    }
}
