/*-----------------------------------------------------------------------------
 * Enhydra Java Application Server
 * Copyright 1997-1999 Lutris Technologies, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes Enhydra software developed by Lutris
 *      Technologies, Inc. and its contributors.
 * 4. Neither the name of Lutris Technologies nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY LUTRIS TECHNOLOGIES AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL LUTRIS TECHNOLOGIES OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *-----------------------------------------------------------------------------
 * $Id: DOTableComboEditor.java,v 1.5 1999/07/23 22:02:08 jay Exp $
 *-----------------------------------------------------------------------------
 */



package dods.gui.table;

import dods.gui.*;
import dods.data.*;
import dods.gui.tree.*;
import javax.swing.JComboBox;
import javax.swing.DefaultCellEditor;
import javax.swing.JTable;
import javax.swing.JTree;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Vector;
/**
 * This class is the editor which shows a dropdown list of choices for that cell.
 * It is currently only used for one column.
 *
 * @author  Philip Martin
 * @version $Revision: 1.5 $
 */
public final class DOTableComboEditor extends DefaultCellEditor implements ActionListener {
    private JComboBox editor;
    private JTable table;
    private int column;
    private JTree tree;
    /**
     * The constructor initializes the combo box given all of the parameters
     * which define where the column and cells are.
     */
    public DOTableComboEditor(DataObjectApplication doa, JTree tree, JTable table, int column) {
        super(new JComboBox());
        this.column = column;
        this.table = table;
        this.tree = tree;
        if(column==6) {
            initializeEditor(column);
        }
        else {
        }
    }
    /**
     * This method sets which items are in the list of choices.
     */
    public void initializeEditor(int col){
        editor = new JComboBox();
        if(col == 6) {
            Vector DOS = new Vector();
            ((DOPackage)((DOTreeNode)tree.getModel().getRoot()).getDataObject()).getAllDataObjects(DOS);
            editor.addItem("String");
            editor.addItem("java.math.BigDecimal");
            editor.addItem("boolean");
            editor.addItem("byte");
            editor.addItem("short");
            editor.addItem("int");
            editor.addItem("long");
            editor.addItem("float");
            editor.addItem("double");
            editor.addItem("byte[]");
            editor.addItem("java.sql.Date");
            editor.addItem("java.sql.Time");
            editor.addItem("java.sql.Timestamp");
            for(int i = 0; i < DOS.size(); i++) {
                if(!((DataObject)DOS.elementAt(i)).isAbstract()) {
                    editor.addItem(((DataObject)DOS.elementAt(i)).toString());
                }
            }
        }
        editorComponent = editor;
    }
    /**
     * @return The combobox which is being used.
     */
    public JComboBox getEditor() {
        return editor;
    }
    /**
     * When a new value is chosen, this method tells the cell to stop editing
     */
    public void actionPerformed(ActionEvent e) {
	/*
        DOTableComboEditor six = (DOTableComboEditor)table.getColumnModel().getColumn(8).getCellEditor();
        six.stopCellEditing();
	*/
    }
}
