#!/usr/bin/perl -w
# jparker@tridgell, 19990830
# call as 
# $ check_links *.m4

#
#  Copyright (C) 1999 Plugged In Software Pty Ltd.
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#  Plugged In Software
#  PO Box 4130
#  St. Lucia South Queensland
#  Australia  4067
#  info@PIsoftware.com
#

# output:
# number of references   offending filename::   where it's referenced.

# this is just a quick hack, better would be to act recursively,
# and accecpt backslashes in filenames, and so on.

use strict;

my %count;
my $i;

$" = ", ";

while(<>) {
  if(/"(\w+)\.html"/i) {
    if((defined(@{$count{$1}}) && @{$count{$1}}[-1] ne $ARGV) || !defined(@{$count{$1}})) {
      push @{$count{$1}},$ARGV if ! -e "$1.m4";
    }
  }
}

foreach $i ( sort { $count{$b} <=> $count{$a}
                    || length($b) <=> length($a)
                      || $b cmp $a
                      } keys %count ) {
  print scalar(@{$count{$i}})," $i\:\:\t@{$count{$i}}\n";
}
