#
# platypus
# Enhydra Application Makefile Configuration
#
#

#
# The directory containing the Enhydra distribution.
#
ENHYDRA_DIR = /usr/local/enhydra

# TODO: This JDKDIR value (jdk117_v1a) is a bit messy. Should have a jdk/ directory. 
JDKDIR = /usr/local/java
ENHYDRA_CLASSES = $(ENHYDRA_DIR)/output/lib/enhydra.jar
JOLTC = $(ENHYDRA_DIR)/output/bin/joltc 
XMLC = /usr/local/XMLC/output/bin/xmlc


APP_NAME = com.pisoftware.platypus
APP_DIR = $(shell echo $(APP_NAME) | tr . /)
GEN_DIR = $(ROOT)/$(APP_DIR)
SRC_DIR = $(ROOT)/src
CLASS_DIR = $(ROOT)/classes/$(APP_DIR)
TMP_DIR=$(ROOT)/tmp
VIEW_DIR=$(ROOT)/view
HTML_XMLC_OPTS_FILE = $(ROOT)/config.xmlc

# NOTE: Some rules in stdrules.mk have HTML_XMLC_OPTS_FILE as a
# prerequisite. If it isn't defined, their targets will always be 'out
# of date'!


JAVADOCFLAGS = -private -author -version

#
# You may need to set other values to override the defaults, for example:
#
# JDKDIR = /usr/local/jdk1.1.5
# JSDKDIR = ...
# WAIDIR = ...  (optional)
# SWINGDIR = ...  (optional)
#
# See lib/stdrules.mk in the Enhydra installation for more
# configuration settings.
#


# Extra classpath information required
XTRA_CLASSPATH = /usr/local/XMLC/output/lib/xmlc.jar


#
# What is the name of the jar file to create?
#
JARNAME = platypus

include $(ROOT)/stdrules.mk

#
# Only used if ENHYDRA_DIR is not correct.
#
$(ROOT)/stdrules.mk:
	@echo
	@echo "Please edit config.mk. ENHYDRA_DIR must point to your installation of Enhydra."
	@echo
