package com.pisoftware.platypus.production ; 

import org.w3c.dom.*;
import org.w3c.dom.html.*;
import java.lang.*;
import java.util.*;
/** 
 * Lists <CODE>Comment</CODE> nodes which have a given string as their content.
 **/


/*
 *  Copyright (C) 1999 Plugged In Software Pty Ltd.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Plugged In Software
 *  PO Box 4130
 *  St. Lucia South Queensland
 *  Australia  4067
 *  info@PIsoftware.com
 */

public class ListCommentContentNodes extends ListDOMNodes{

  /** 
   * Determines whether a node should be returned. It
   * returns true if this node is Comment with a given content. 
   **/
  protected boolean filter( Node node ){ 
    Comment comment ; 
    String commentData ; // Data in 'comment'
    String content = (String) param1 ; 
    if( ! Comment.class.isInstance( node ) ){ 
      return false ;
    }else{
      comment = (Comment) node ; 
      commentData = comment.getData(); 
      if( null == commentData ){
        return false ; 
      }else{ 
        return content.equals( comment.getData() ); 
      }
    }
  }

  public ListCommentContentNodes( Node node, String content ){ 
    super( node, content );
  }

}
