package com.pisoftware.platypus.production ; 

import org.w3c.dom.*;
import org.w3c.dom.html.*;
import java.lang.*;
import java.util.*;

/** 
 * TODODOCO: some Javadoc on what this class does. 
 * 
 * <P>
 * 
 * <B>WARNING</B>: This class, and its subclasses, are used by the
 * ProdUtil class. So, to prevent compilation circularities, this
 * class and its subclasses <B>can not use</B> methods from ProdUtil.
 * 
 * <P>
 * 
 * <B>WARNING</B>: If you're thinking about writing a class which
 * extends this class, fine. That is, fine unless you want to
 * parameterise the filter criterion. Be aware that the nodes are
 * filtered by this classes constructor! This means that your code has
 * <EM>no</EM> opportunity to set fields in your class until after all
 * the filtering has occurred. (Arrgghh! Much nashing of teeth!)
 **/


/*
 *  Copyright (C) 1999 Plugged In Software Pty Ltd.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Plugged In Software
 *  PO Box 4130
 *  St. Lucia South Queensland
 *  Australia  4067
 *  info@PIsoftware.com
 */

public class ListDOMNodes implements Enumeration{

  /** Document whose nodes we're enumerating **/
  Document document ; 

  /** All nodes accepted by filter **/
  Vector nodes ; 

  /** Index of next node to return.  **/
  int nodeI ; 

  /** Object for parameterising the filter. **/
  protected Object param1 ; 

  // Variables vectorInitSize and vectorIncrSize are tuning parameters
  // used while building nodes[]. They can be altered in subclasses to
  // improve performance, but do not affect the correctness of the
  // code (so long as they are positive).
  protected int vectorInitSize = 500 ; 
  protected int vectorIncrSize = 500 ; 

  // Method filter() determines whether a node should be returned. It
  // can be over-ridden in subclasses to change the set of nodes
  // returned.
  protected boolean filter( Node node ){ 
      return true ; 
  }

  public Object nextElement(){ 
      Object next = nodes.elementAt(nodeI) ; 
      nodeI ++ ; 
      return next ; 
  }

  public Node nextNode(){ 
      return (Node) nextElement(); 
  }

  public boolean hasMoreElements(){ 
      return nodeI < nodes.size() ; 
  }

  private void appendNodeTree( Node node ){ 
      NodeList children ; 
      int childI, childCount ; 
      if( filter( node ) ) nodes.addElement( node ); 
      children = node.getChildNodes(); 
      childCount = children.getLength(); 
      for( childI=0 ; childI<childCount ; childI++ ){ 
        appendNodeTree( children.item(childI) ); 
      }
  }

  public ListDOMNodes( Node root ){ 
      nodes = new Vector( vectorInitSize, vectorIncrSize ); 
      this.document = document ; 
      appendNodeTree( root ); 
      nodeI = 0 ; 
  }

  public ListDOMNodes( Node root, Object param1 ){ 
      this.param1 = param1 ; 
      nodes = new Vector( vectorInitSize, vectorIncrSize ); 
      this.document = document ; 
      appendNodeTree( root ); 
      nodeI = 0 ; 
  }

  public ListDOMNodes( Document document ){ 
      nodes = new Vector( vectorInitSize, vectorIncrSize ); 
      this.document = document ; 
      appendNodeTree( document.getDocumentElement() ); 
      nodeI = 0 ; 
  }
}
