package com.pisoftware.platypus.production ; 

import org.w3c.dom.*;
import org.w3c.dom.html.*;
import java.lang.*;
import java.util.*;


/*
 *  Copyright (C) 1999 Plugged In Software Pty Ltd.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Plugged In Software
 *  PO Box 4130
 *  St. Lucia South Queensland
 *  Australia  4067
 *  info@PIsoftware.com
 */

public class ListFormElementNodes extends ListDOMNodes{

  // TODOONEDAY: Should handle FORM element tag BUTTON. Like, one day,
  // when one of the browsers handle it.

  // TODOONEDAY: Add an option to remove duplicate RADIO buttons. That is,
  // only allow the first RADIO button of a set to go through.

  /** 
   * Method filter() determines whether a node should be returned. It
   * returns true if this node is a FORM element, ie an INPUT or a
   * TEXTAREA.
   **/
  static public boolean isFormElement( Node node ){ 
    HTMLElement el ; 
    String tagName ; 
    if( ! (node instanceof HTMLElement) ) return false ; 
    el = (HTMLElement) node ; 
    // OLDCODE try{ 
    // OLDCODE   el = (HTMLElement) node ; 
    // OLDCODE }catch( Exception e ){ return false ; }
    tagName = el.getTagName(); 
    if( "INPUT".equalsIgnoreCase( tagName ) ) return true ; 
    if( "TEXTAREA".equalsIgnoreCase( tagName ) ) return true ; 
    if( "SELECT".equalsIgnoreCase( tagName ) ) return true ; 
    return false ; 
  }

  protected boolean filter( Node node ){ 
    return isFormElement( node ); 
  }

  public ListFormElementNodes( Node node ){ 
    super( node );
  }

}
