package com.pisoftware.platypus.production ; 

import org.w3c.dom.*;
import org.w3c.dom.html.*;
import java.lang.*;
import java.util.*;


/*
 *  Copyright (C) 1999 Plugged In Software Pty Ltd.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Plugged In Software
 *  PO Box 4130
 *  St. Lucia South Queensland
 *  Australia  4067
 *  info@PIsoftware.com
 */

public class ListNodesWithID extends ListDOMNodes{

  String showMap( NamedNodeMap map ){ 
    int i ; 
    StringBuffer ret = new StringBuffer( "************ " ); 
    for( i=0 ; i<map.getLength() ; i++ ){ 
        ret.append( map.item(i).toString() + " **** " ); 
    }
    return ret.toString(); 
  }


  /** 
   * @return true if this node has an ID attribute.
   **/
  public static boolean hasIDAttr( Node node ){ 
    // WARNING: There is a problem with the case of the attribute!
    // It seems Docuverse expect "ID" to be uppercase, but OpenXLM
    // expect it to be lowercase :-(
    NamedNodeMap map ; 
    Node idAttr ; 
    map = node.getAttributes(); 
    idAttr = null ; 
    if( null != map ){ 
      idAttr = map.getNamedItem( "id" ); // OpenXML
      if( null == idAttr ) idAttr = map.getNamedItem( "ID" ); // Docuverse
    }
    // DBG 
    // System.err.print( "" + (null != idAttr) ); 
    // if( null != idAttr ) System.err.print( "\t" + ((Attr)idAttr).getValue() ); 
    // System.err.println(); 
    return null != idAttr ; 
  }


  /** 
   * Determines whether a node should be returned. 
   * @return true if this node has an ID attribute.
   **/
  protected boolean filter( Node node ){ 
    return hasIDAttr( node ); 
  }


  public ListNodesWithID( Node node ){ 
    super( node );
  }


  public ListNodesWithID( Document document ){ 
    super( document );
  }

}
