package com.pisoftware.platypus.production;

import com.lutris.appserver.server.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.sql.ObjectId;
import com.lutris.util.*;
import java.util.*;

/**
 *  Author: <A HREF="MAILTO:cryan@plugged.net.au">Chris Ryan</A>
 *<P>
 * Company: Plugged In Software<BR>
 *          P.O. Box 4130<BR>
 *          St Lucia South<BR>
 *          Brisbane Queensland 4067<BR>
 *          Australia<BR>
 * <A HREF="http://www.plugged.net.au/">http://www.plugged.net.au</A><BR>
 *<P>
 *    Date: 18 May 1999
 *<P>
 * Purpose: This class holds details about a pulldown item
 *          including value, display value, etc. 
 *
 */

/*
 *  Copyright (C) 1999 Plugged In Software Pty Ltd.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Plugged In Software
 *  PO Box 4130
 *  St. Lucia South Queensland
 *  Australia  4067
 *  info@PIsoftware.com
 */

public class PulldownItem {


  // Holders for Pulldown information
  private String id = null;
  private String value = null;
  private String display_value = null;
  private boolean is_default  = false;


/**
 * Constructor.  Creates the object, and initialises the
 * appropriate variables, etc.
 */
  public PulldownItem() {

  }


/**
 * Constructor.  Creates the object, and initialises the
 * appropriate variables, etc.
 *
 * @param id  The id to which this pulldown item is associated
 * @param value  The value for this pulldown item
 * @param display_value  The display value for this pulldown item
 * @param is_default  True if this is a default pulldown item
 */
  public PulldownItem(String id, String value, String display_value, boolean is_default) {

    this.id = id;
    this.value = value;
    this.display_value = display_value;
    this.is_default = is_default;

  }


// get methods


/**
 * Returns the id for this pulldown item
 *
 * @return see comment
 */
  public String getId() {

    return id;

  }


/**
 * Returns the value for this pulldown item
 *
 * @return see comment
 */
  public String getValue() {

    return value;

  }


/**
 * Returns the display value for this pulldown item
 *
 * @return see comment
 */
  public String getDisplayValue() {

    return display_value;

  }


/**
 * Returns true if this pulldown item is the default value
 *
 * @return see comment
 */
  public boolean isDefault() {

    return is_default;

  }


// set methods


/**
 * Sets the id for this pulldown item
 *
 * @return see comment
 */
  public void setId(String id) {

    this.id = id;

  }


/**
 * Sets the value for this pulldown item
 *
 * @return see comment
 */
  public void setValue(String value) {

    this.value = value;

  }


/**
 * Sets the display value for this pulldown item
 *
 * @return see comment
 */
  public void setDisplayValue(String display_value) {

    this.display_value = display_value;

  }


/**
 * Sets true if this pulldown item is the default value
 *
 * @return see comment
 */
  public void setDefault(boolean is_default) {

    this.is_default = is_default;

  }


}

