package com.pisoftware.platypus.production;

import java.io.*;
import java.lang.*;
import java.util.*;
import com.pisoftware.platypus.production.*;

/** 
 * This exception is thrown when the user attempts to create a new
 * record which conflicts with an existing record, under the database's
 * uniqueness constraints.
 **/


/*
 *  Copyright (C) 1999 Plugged In Software Pty Ltd.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Plugged In Software
 *  PO Box 4130
 *  St. Lucia South Queensland
 *  Australia  4067
 *  info@PIsoftware.com
 */


public class UserDuplicateRecordException extends UserException{


  public UserDuplicateRecordException( String message ){ 
    super( message );  
  }


  public UserDuplicateRecordException( String message, Exception e ){ 
    super( message, e );  
  }


  public UserDuplicateRecordException( String message, String backURL ){ 
    super( message, backURL );  
  }


  public UserDuplicateRecordException( String message, String backURL, Exception e ){ 
    super( message, backURL, e ); 
  }
}
