// $Id: SortInterface.java,v 1.3 1999/10/26 00:31:27 cryan Exp $

package com.pisoftware.quicksort;

import java.lang.*;
import java.util.*;
import java.io.*;

// Interface:  SortInterface

/**
 *
 *  Version: 0.1<p>
 *
 *  Author: <A HREF="MAILTO:cryan@plugged.net.au">Chris Ryan</A><p>
 *
 *  Company: <blocquote>Plugged In Software<br>
 *           P.O. Box 4130<br>
 *           St Lucia South<br>
 *           Brisbane Qld Australia 4067<br>
 *           <a href=http://www.plugged.net.au>http://www.plugged.net.au</a><br>
 *<p>
 *  Date:    09 September 1997
 *<p>
 *<dl><dt>Purpose:
 *    <dd>This class provides a callback mechanism for the
 *        Sort class for sorting objects in a vector.
 *</dl>
 */

/*
 *  Copyright (C) 1999 Plugged In Software Pty Ltd.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Plugged In Software
 *  PO Box 4130
 *  St. Lucia South Queensland
 *  Australia  4067
 *  info@PIsoftware.com
 */


public interface SortInterface {


/** 
 * Compares this object to the object passed.  Returns 0 if they are equal, 
 * -1 if this object is less than passed object, and 1 if this object 
 * is greater than passed object.
 *
 * @param compare_object  The object to compare to
 * @param flags  Any flags to use in the comparison test, may be null
 * @return see above comment...
 */
  public int compareTo(Object compare_object, Object flags);

}
