package org.enhydra.xml.binding;

/**
 * <p>
 *   <code>BindingUtils</code> is a utility class with lots of static methods
 *     that are used as utilities for the rest of the Enhydra Data Binding
 *     classes.
 * </p>
 *
 * @author Brett McLaughlin
 */
public final class BindingUtils {

    /**
     * <p>
     *  This will take a <code>String</code> and return the <code>String</code>
     *    with the first letter as uppercase. Note that if the first letter is
     *    a non-alphabetic character, such as an underscore, this doesn't change
     *    the character. It also makes no changes to the rest of the
     *    <code>String</code>.
     * </p>
     *
     * @param str <code>String</code> to operate upon.
     * @return <code>String</code> - modified <code>String</code>.
     */
    public static String initialCaps(String str) {
        return new StringBuffer()
            .append(Character.toUpperCase(str.charAt(0)))
            .append(str.substring(1))
            .toString();
    }

    /**
     * <p>
     *  This will take a <code>String</code> and return the <code>String</code>
     *    with the first letter as lowercase. Note that if the first letter is
     *    a non-alphabetic character, such as an underscore, this doesn't change
     *    the character. It also makes no changes to the rest of the
     *    <code>String</code>.
     * </p>
     *
     * @param str <code>String</code> to operate upon.
     * @return <code>String</code> - modified <code>String</code>.
     */
    public static String initialLowercase(String str) {
        return new StringBuffer()
            .append(Character.toLowerCase(str.charAt(0)))
            .append(str.substring(1))
            .toString();
    }

}
