package timesheet.business;

import timesheet.*;
import timesheet.data.*;
import java.util.*;
import com.lutris.appserver.server.*;
import com.lutris.appserver.server.sql.*;
import com.lutris.dods.builder.sourceGenerators.Query.*;
import java.sql.*;
import java.math.*;
import com.pisoftware.platypus.production.*;


/**
 * Date Created: Oct 15, 1999
 * <P>
 * Purpose:  This class provides the business logic associated with
 *           a Activity.  It should probably be used by other BOs only.
 *
 */
public class ActivityBO extends ActivityBDO {


/**
 * Constructor.  Creates the object, and initialises the
 * appropriate variables, etc.
 * 
 * @exception Exception thrown by BDO constructor.  :-(
 */
  public ActivityBO() throws Exception {

    super();

  }


/*
  No getIdValue Method(s) Generated!
*/


/**
 * getAllActivities: generated by Squirt!
 *
 * <JAVADOC_PARAMETERS>
 * @return an array of ActivityDOs for this query
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public ActivityDO[] getAllActivities() throws ApplicationException {

    ActivityDO[] results = null;
    ActivityQuery query = new ActivityQuery();

    try {

      
      query.addOrderByActivityName(); 

      

      results = query.getDOArray();

    } catch (DataObjectException doe) {

      throw new ApplicationException( "Unable to create existing Activity Data Object", doe );

    } catch ( NonUniqueQueryException nuqe ) {

      // ...this exception will only occur is requireUniqueInstance was called.
      throw new ApplicationException( "Non unique result!", nuqe );  

    }

    // return the results found, if any
    return results;

  }


    // 'cache' for query - createExisting can be a time expensive call...
    private String findActivity_ObjectId = "";
    private ActivityDO findActivity_DO = null;


/**
 * findActivity: generated by Squirt!  This query is for
 * finding a record in a table by ObjectId.  The row
 * must be in the table, otherwise an exception will
 * be thrown.
 *
 * @param objectid  The record to retrieve from Activity
 * @return an array of ActivityDOs for this query
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public ActivityDO findActivity(String objectid) throws ApplicationException {

    // DBG
    // System.err.println("OBJECTID for findActivity: "+objectid);

    // have we just referenced this object id?
    if (objectid.equals(findActivity_ObjectId)) {

      // yes, use our cached version
      return findActivity_DO;

    }

    ActivityDO result = null;

    try {

      java.math.BigDecimal bd = new java.math.BigDecimal(objectid);
      result = ActivityDO.createExisting(bd);

      // keep details in our cache
      findActivity_ObjectId = objectid;
      findActivity_DO = result;

    } catch (Exception e) {

      throw new ApplicationException("Unable to create existing Activity Data Object", e );

    }

    // return the results found, if any
    return result;

  }



}

