package timesheet.business;

import timesheet.*;
import timesheet.data.*;
import java.util.*;
import com.lutris.appserver.server.*;
import com.lutris.appserver.server.sql.*;
import com.lutris.dods.builder.sourceGenerators.Query.*;
import java.sql.*;
import java.math.*;
import com.pisoftware.platypus.production.*;


/**
 * Date Created: Oct 15, 1999
 * <P>
 * Purpose:  This class provides the business logic associated with
 *           a Company.  It should probably be used by other BOs only.
 *
 */
public class CompanyBO extends CompanyBDO {


/**
 * Constructor.  Creates the object, and initialises the
 * appropriate variables, etc.
 * 
 * @exception Exception thrown by BDO constructor.  :-(
 */
  public CompanyBO() throws Exception {

    super();

  }


/*
  No getIdValue Method(s) Generated!
*/

    // 'cache' for query - createExisting can be a time expensive call...
    private String findCompany_ObjectId = "";
    private CompanyDO findCompany_DO = null;


/**
 * findCompany: generated by Squirt!  This query is for
 * finding a record in a table by ObjectId.  The row
 * must be in the table, otherwise an exception will
 * be thrown.
 *
 * @param objectid  The record to retrieve from Company
 * @return an array of CompanyDOs for this query
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public CompanyDO findCompany(String objectid) throws ApplicationException {

    // have we just referenced this object id?
    if (objectid.equals(findCompany_ObjectId)) {

      // yes, use our cached version
      return findCompany_DO;

    }

    CompanyDO result = null;

    try {

      java.math.BigDecimal bd = new java.math.BigDecimal(objectid);
      result = CompanyDO.createExisting(bd);

      // keep details in our cache
      findCompany_ObjectId = objectid;
      findCompany_DO = result;

    } catch (Exception e) {

      throw new ApplicationException("Unable to create existing Company Data Object", e );

    }

    // return the results found, if any
    return result;

  }



/**
 * getAllCompanies: generated by Squirt!
 *
 * <JAVADOC_PARAMETERS>
 * @return an array of CompanyDOs for this query
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public CompanyDO[] getAllCompanies() throws ApplicationException {

    CompanyDO[] results = null;
    CompanyQuery query = new CompanyQuery();

    try {

      
      
      

      results = query.getDOArray();

    } catch (DataObjectException doe) {

      throw new ApplicationException( "Unable to create existing Company Data Object", doe );

    } catch ( NonUniqueQueryException nuqe ) {

      // ...this exception will only occur is requireUniqueInstance was called.
      throw new ApplicationException( "Non unique result!", nuqe );  

    }

    // return the results found, if any
    return results;

  }



}

