package timesheet.presentation.maintenance;

import java.util.*;
// import java.net.URLEncoder;
import org.w3c.dom.*;
import org.w3c.dom.html.*;
import com.lutris.util.*;
import com.lutris.xml.xmlc.*;
import com.lutris.appserver.server.ApplicationException;
import com.lutris.appserver.server.sql.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.pisoftware.platypus.production.*;
import timesheet.presentation.*; 
import timesheet.presentation.maintenance.*; 
import timesheet.business.*; 
import timesheet.business.maintenance.*; 
import timesheet.data.*; 
import timesheet.util.*; 

/** 
 * Class EditPersonList manipulates the DOM
 * model created by class EditPersonList. 
 * 
 * TO DO: More detailed doco on what this class does.
 * 
 * Generated by Platypus version 1.0.
 **/

public class EditPersonList extends EditPersonListBASE{


  //////  Miscellaneous variables for presentation object
  // Query string and database variables are in a lower section.
  /** URL to which we will redirect the browser, after this class does its work. **/
  String redirectURL ; 
  //////  Variables for the query string values
  ////  Form  'MainForm' in 'maintenance.EditPersonQuery' PO invokes URL  'EditPersonList.po'

  /** Value of 'CompanyId' on query string, from MainForm form on editPersonList PO **/
  String qsCompanyId ; 

  /** Value of 'FirstName' on query string, from MainForm form on editPersonList PO **/
  String qsFirstName ; 

  /** Value of 'Title' on query string, from MainForm form on editPersonList PO **/
  String qsTitle ; 

  /** Value of 'Phone' on query string, from MainForm form on editPersonList PO **/
  String qsPhone ; 

  /** Value of 'Surname' on query string, from MainForm form on editPersonList PO **/
  String qsSurname ; 

  /** Value of '_noattr' on query string, from MainForm form on editPersonList PO **/
  String qs_noattr ; 

  /** Value of 'Type' on query string, from MainForm form on editPersonList PO **/
  String qsType ; 

  /** Value of 'UserName' on query string, from MainForm form on editPersonList PO **/
  String qsUserName ; 

  /** Value of 'Email' on query string, from MainForm form on editPersonList PO **/
  String qsEmail ; 

  /** Value of 'Fax' on query string, from MainForm form on editPersonList PO **/
  String qsFax ; 

  //////  Variables for database query.

  //////  Declarations for DB query for PersonTable

  /** Count of records returned by PersonTable DB query. **/
  int countPersonTable ;
  /** Loop index **/
  int iPersonTable ; 

  /** Clone of prototype node, after prototype is filled with data. **/
  Node newPersonTable ; 

  // /** List of ID nodes in a cloned access tree. **/
  // Hashtable idnodesPersonTable ; 


  /** ID FirstName from DB query on PersonTable **/
  String fieldFirstName ; 

  /** ID AuthorisationLevel from DB query on PersonTable **/
  String fieldAuthorisationLevel ; 

  /** ID Title from DB query on PersonTable **/
  String fieldTitle ; 

  /** ID Phone from DB query on PersonTable **/
  String fieldPhone ; 

  /** ID ObjectId from DB query on PersonTable **/
  String fieldObjectId ; 

  /** ID Surname from DB query on PersonTable **/
  String fieldSurname ; 

  /** ID Type from DB query on PersonTable **/
  String fieldType ; 

  /** ID UserName from DB query on PersonTable **/
  String fieldUserName ; 

  /** ID Email from DB query on PersonTable **/
  String fieldEmail ; 

  /** ID CompanyName from DB query on PersonTable **/
  String fieldCompanyName ; 

  /** ID Fax from DB query on PersonTable **/
  String fieldFax ; 

  // End of database field declarations section. 


  /** 
   * Does the actual manipulation of the DOM data structure. 
   * 
   * It defines the abstract method in EditPersonListBASE.java.  
   * 
   * @exception ApplicationException
   * @exception HttpPresentationException
   **/
  public void manipulate() throws ApplicationException, HttpPresentationException {

    //////  Initialise
    bo = new EditPersonListBO( comms ); // Do not delete. May do user authentification, etc.
    //// Set DEBUG flag
    DEBUG = false ; 
    if( ProdUtil.nameInQueryString( args, "DEBUG" ) ) DEBUG = true ; 
    if( ProdUtil.sessionDebugFlag( debugData ) ) DEBUG = true ; 

    //////  Get values from query string 
    qsCompanyId = ProdUtil.getFromQueryString( args, "CompanyId" );
    qsFirstName = ProdUtil.getFromQueryString( args, "FirstName" );
    qsTitle = ProdUtil.getFromQueryString( args, "Title" );
    qsPhone = ProdUtil.getFromQueryString( args, "Phone" );
    qsSurname = ProdUtil.getFromQueryString( args, "Surname" );
    qs_noattr = ProdUtil.getFromQueryString( args, "_noattr" );
    qsType = ProdUtil.getFromQueryString( args, "Type" );
    qsUserName = ProdUtil.getFromQueryString( args, "UserName" );
    qsEmail = ProdUtil.getFromQueryString( args, "Email" );
    qsFax = ProdUtil.getFromQueryString( args, "Fax" );

    // DBG
    ProdUtil.log( "Query string pair: 'CompanyId' = '" + qsCompanyId + "'" );
    ProdUtil.log( "Query string pair: 'FirstName' = '" + qsFirstName + "'" );
    ProdUtil.log( "Query string pair: 'Title' = '" + qsTitle + "'" );
    ProdUtil.log( "Query string pair: 'Phone' = '" + qsPhone + "'" );
    ProdUtil.log( "Query string pair: 'Surname' = '" + qsSurname + "'" );
    ProdUtil.log( "Query string pair: '_noattr' = '" + qs_noattr + "'" );
    ProdUtil.log( "Query string pair: 'Type' = '" + qsType + "'" );
    ProdUtil.log( "Query string pair: 'UserName' = '" + qsUserName + "'" );
    ProdUtil.log( "Query string pair: 'Email' = '" + qsEmail + "'" );
    ProdUtil.log( "Query string pair: 'Fax' = '" + qsFax + "'" );


    //////  Fill dynamic nodes
    //////  Processing records from DB query for ID PersonTable
    countPersonTable = bo.getPersonTable( qsFirstName, qsSurname, qsTitle, qsEmail, qsPhone, qsFax, qsType, qsUserName, qsCompanyId ); 
    if( countPersonTable > 0 ){ 
      // DBG 
      ProdUtil.debug( "Query on PersonTable returned " + countPersonTable + " records." ); 

      for( iPersonTable=0 ; iPersonTable<countPersonTable ; iPersonTable++ ){
    
        ////////  Get field values from a PersonTable record

        ////  In access PersonTable, processing ID FirstName
        fieldFirstName = bo.getIdValue( iPersonTable, "FirstName", "" ); 
        fieldFirstName = ProdUtil.cleanString( fieldFirstName, true ); 
        XMLCUtil.getFirstText( protoFirstName ).setData( fieldFirstName ); 

        ////  In access PersonTable, processing ID AuthorisationLevel
        fieldAuthorisationLevel = bo.getIdValue( iPersonTable, "AuthorisationLevel", "" ); 
        fieldAuthorisationLevel = ProdUtil.cleanString( fieldAuthorisationLevel, true ); 
        XMLCUtil.getFirstText( protoAuthorisationLevel ).setData( fieldAuthorisationLevel ); 

        ////  In access PersonTable, processing ID Title
        fieldTitle = bo.getIdValue( iPersonTable, "Title", "" ); 
        fieldTitle = ProdUtil.cleanString( fieldTitle, true ); 
        XMLCUtil.getFirstText( protoTitle ).setData( fieldTitle ); 

        ////  In access PersonTable, processing ID Phone
        fieldPhone = bo.getIdValue( iPersonTable, "Phone", "" ); 
        fieldPhone = ProdUtil.cleanString( fieldPhone, true ); 
        XMLCUtil.getFirstText( protoPhone ).setData( fieldPhone ); 

        ////  In access PersonTable, processing ID ObjectId
        fieldObjectId = bo.getIdValue( iPersonTable, "ObjectId", FormatUtil.DRILL + "EditPersonForm.po?PersonId=" ); 
        fieldObjectId = ProdUtil.cleanString( fieldObjectId, false ); 
        protoObjectId.setAttribute( "href", fieldObjectId ); 
        if( ! ProdUtil.stringHasContent( fieldObjectId ) ){  // Handle missing value
          ProdUtil.replaceNodeWithChildren( protoObjectId); // Removes the node but *not* its children.
        } 

        ////  In access PersonTable, processing ID Surname
        fieldSurname = bo.getIdValue( iPersonTable, "Surname", "" ); 
        fieldSurname = ProdUtil.cleanString( fieldSurname, true ); 
        XMLCUtil.getFirstText( protoSurname ).setData( fieldSurname ); 

        ////  In access PersonTable, processing ID Type
        fieldType = bo.getIdValue( iPersonTable, "Type", "" ); 
        fieldType = ProdUtil.cleanString( fieldType, true ); 
        XMLCUtil.getFirstText( protoType ).setData( fieldType ); 

        ////  In access PersonTable, processing ID UserName
        fieldUserName = bo.getIdValue( iPersonTable, "UserName", "" ); 
        fieldUserName = ProdUtil.cleanString( fieldUserName, true ); 
        XMLCUtil.getFirstText( protoUserName ).setData( fieldUserName ); 

        ////  In access PersonTable, processing ID Email
        fieldEmail = bo.getIdValue( iPersonTable, "Email", "" ); 
        fieldEmail = ProdUtil.cleanString( fieldEmail, true ); 
        XMLCUtil.getFirstText( protoEmail ).setData( fieldEmail ); 

        ////  In access PersonTable, processing ID CompanyName
        fieldCompanyName = bo.getIdValue( iPersonTable, "CompanyName", "" ); 
        fieldCompanyName = ProdUtil.cleanString( fieldCompanyName, true ); 
        XMLCUtil.getFirstText( protoCompanyName ).setData( fieldCompanyName ); 

        ////  In access PersonTable, processing ID Fax
        fieldFax = bo.getIdValue( iPersonTable, "Fax", "" ); 
        fieldFax = ProdUtil.cleanString( fieldFax, true ); 
        XMLCUtil.getFirstText( protoFax ).setData( fieldFax ); 

        // DBG 
        ProdUtil.debug( "Filled access PersonTable record #" + iPersonTable ); 

        //////  Hey! If there was only one record, go straight to the next page of the workflow 
        // Note: this section is usually used on LIST pages.
        if( 1 == countPersonTable ){ 
          //////  Exactly one record found. Go to next page in workflow.
          // NOTE: ClientPageRedirect assumes absolute pathnames, *not* relative.
          redirectURL = ProdUtil.URLAppAbsoluteDir( fieldObjectId, "maintenance" ) ; 
          throw new ClientPageRedirectException( comms.request.getAppFileURIPath(redirectURL));
        } 
        //////  Set up alternating CLASS attributes. 
        // NOTE: Mostly used for table rows when each is a DB record.
        ProdUtil.setClassAttributeModulo( protoPersonTable, iPersonTable ); 
        //////  Clone DOM node for PersonTable record, and insert it.
        newPersonTable = protoPersonTable.cloneNode( true ); 
        // idnodesPersonTable = ProdUtil.idHashtable( (HTMLElement) newPersonTable ); 
        ProdUtil.insertSiblingBefore( newPersonTable, protoPersonTable ); 
      }
    }else{
      // There were no PersonTable records returned from DB
      try{ 
        presentationData.set( "RESTOREQUERYSTRING", args );
      }catch( KeywordValueException kve ){
        throw new UserException( "No records were found matching your request." ); 
      }
      throw new UserException( "No records were found matching your request.", "EditPersonQuery.po?RESTOREQUERYSTRING=TRUE" ); 
    }
    
    //////  Remove prototype from DOM  
    ProdUtil.removeThisNode( protoPersonTable ); 

    //////  Restoring FORMS, if necessary
    if( ProdUtil.nameInQueryString( args, "RESTOREQUERYSTRING" ) ){ 
      ProdUtil.restoreFormsFromPresentationData( document, presentationData ); 
    }

    //////  Generate debugging information, if requested.
    if( DEBUG ){ 
      HTMLElement debugTemplate ; 
      //// Fill in debugging information
      debugTemplate = startDebugTemplate(); // Method is in BASE class.
      //// Insert debugging information into DOM tree.
      HTMLBodyElement bodyElement = ProdUtil.getBodyElement( document ); 
      bodyElement.insertBefore( debugTemplate, null ); 
    }
  }
}
