package timesheet.presentation.entry;

import java.util.*;
// import java.net.URLEncoder;
import org.w3c.dom.*;
import org.w3c.dom.html.*;
import com.lutris.util.*;
import com.lutris.xml.xmlc.*;
import com.lutris.appserver.server.ApplicationException;
import com.lutris.appserver.server.sql.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.pisoftware.platypus.production.*;
import timesheet.presentation.*; 
import timesheet.presentation.entry.*; 
import timesheet.business.*; 
import timesheet.business.entry.*; 
import timesheet.data.*; 
import timesheet.util.*; 

/** 
 * Class AddOneItemCommit manipulates the DOM
 * model created by class AddOneItemCommit. 
 * 
 * TO DO: More detailed doco on what this class does.
 * 
 * Generated by Platypus version 1.0.
 **/

public class AddOneItemCommit extends AddOneItemCommitBASE{


  //////  Miscellaneous variables for presentation object
  // Query string and database variables are in a lower section.
  /** URL to which we will redirect the browser, after this class does its work. **/
  String redirectURL ; 
  //////  Variables for the query string values
  ////  Form  'MainForm' in 'entry.AddOneItemForm' PO invokes URL  'AddOneItemCommit.html'

  /** Value of 'EntryDate' on query string, from MainForm form on addOneItemCommit PO **/
  String qsEntryDate ; 

  /** Value of 'ActivityId' on query string, from MainForm form on addOneItemCommit PO **/
  String qsActivityId ; 

  /** Value of '_noattr' on query string, from MainForm form on addOneItemCommit PO **/
  String qs_noattr ; 

  /** Value of 'GotoEditWorkItemsForm' on query string, from MainForm form on addOneItemCommit PO **/
  String qsGotoEditWorkItemsForm ; 

  /** Value of 'ToDate' on query string, from MainForm form on addOneItemCommit PO **/
  String qsToDate ; 

  /** Value of 'ProjectId' on query string, from MainForm form on addOneItemCommit PO **/
  String qsProjectId ; 

  /** Value of 'FromDate' on query string, from MainForm form on addOneItemCommit PO **/
  String qsFromDate ; 

  /** Value of 'Details' on query string, from MainForm form on addOneItemCommit PO **/
  String qsDetails ; 

  /** Value of 'NrHours' on query string, from MainForm form on addOneItemCommit PO **/
  String qsNrHours ; 

  //////  Variables for database query.

  // End of database field declarations section. 


  /** 
   * Does the actual manipulation of the DOM data structure. 
   * 
   * It defines the abstract method in AddOneItemCommitBASE.java.  
   * 
   * @exception ApplicationException
   * @exception HttpPresentationException
   **/
  public void manipulate() throws ApplicationException, HttpPresentationException {

    //////  Initialise
    bo = new AddOneItemCommitBO( comms ); // Do not delete. May do user authentification, etc.
    //// Set DEBUG flag
    DEBUG = false ; 
    if( ProdUtil.nameInQueryString( args, "DEBUG" ) ) DEBUG = true ; 
    if( ProdUtil.sessionDebugFlag( debugData ) ) DEBUG = true ; 

    //////  Get values from query string 
    qsEntryDate = ProdUtil.getFromQueryString( args, "EntryDate" );
    qsActivityId = ProdUtil.getFromQueryString( args, "ActivityId" );
    qs_noattr = ProdUtil.getFromQueryString( args, "_noattr" );
    qsGotoEditWorkItemsForm = ProdUtil.getFromQueryString( args, "GotoEditWorkItemsForm" );
    qsToDate = ProdUtil.getFromQueryString( args, "ToDate" );
    qsProjectId = ProdUtil.getFromQueryString( args, "ProjectId" );
    qsFromDate = ProdUtil.getFromQueryString( args, "FromDate" );
    qsDetails = ProdUtil.getFromQueryString( args, "Details" );
    qsNrHours = ProdUtil.getFromQueryString( args, "NrHours" );

    // DBG
    ProdUtil.log( "Query string pair: 'EntryDate' = '" + qsEntryDate + "'" );
    ProdUtil.log( "Query string pair: 'ActivityId' = '" + qsActivityId + "'" );
    ProdUtil.log( "Query string pair: '_noattr' = '" + qs_noattr + "'" );
    ProdUtil.log( "Query string pair: 'GotoEditWorkItemsForm' = '" + qsGotoEditWorkItemsForm + "'" );
    ProdUtil.log( "Query string pair: 'ToDate' = '" + qsToDate + "'" );
    ProdUtil.log( "Query string pair: 'ProjectId' = '" + qsProjectId + "'" );
    ProdUtil.log( "Query string pair: 'FromDate' = '" + qsFromDate + "'" );
    ProdUtil.log( "Query string pair: 'Details' = '" + qsDetails + "'" );
    ProdUtil.log( "Query string pair: 'NrHours' = '" + qsNrHours + "'" );


    //////  Database add for AddOneItem
    String oidAddOneItem ; // ObjectId for new/updated record
    try{ 
      // Note: commitAddOneItem() args must be consistent with BO code. 
      // Edit the conf file rather than java code. 
      oidAddOneItem = bo.commitAddOneItem( qsActivityId, qsDetails, qsEntryDate, qsNrHours, qsProjectId ); 
    }catch( UserDuplicateRecordException udre ){ 
      try{ 
        presentationData.set( "RESTOREQUERYSTRING", args ); 
      }catch( KeywordValueException kve ){ 
        ProdUtil.log( "Failed insert into presentationData: RESTOREQUERYSTRING" ); 
      }
      String backURLPO ; 
      backURLPO = "entry/AddOneItemForm" ; // TODO: Check backURLPO is correct. Should be relative PO URL, without suffix.
      udre.backURL = backURLPO + ".po?RESTOREQUERYSTRING=TRUE" ; 
      throw udre ; 
    }
    // DBG
    ProdUtil.log( "oidAddOneItem is '" + oidAddOneItem + "'" ); 

    //////  Fill dynamic nodes

    //////  Processing ID TimeEntryId
    protoTimeEntryId.setAttribute( "value", oidAddOneItem ); 

    //////  Processing ID EntryDate
    protoEntryDate.setAttribute( "value", qsEntryDate ); 

    //////  Processing ID ToDate
    protoToDate.setAttribute( "value", qsToDate ); 

    //////  Processing ID FromDate
    protoFromDate.setAttribute( "value", qsFromDate ); 

    //////  Restoring FORMS, if necessary
    if( ProdUtil.nameInQueryString( args, "RESTOREQUERYSTRING" ) ){ 
      ProdUtil.restoreFormsFromPresentationData( document, presentationData ); 
    }

    //////  Generate debugging information, if requested.
    if( DEBUG ){ 
      HTMLElement debugTemplate ; 
      //// Fill in debugging information
      debugTemplate = startDebugTemplate(); // Method is in BASE class.
      //// Insert debugging information into DOM tree.
      HTMLBodyElement bodyElement = ProdUtil.getBodyElement( document ); 
      bodyElement.insertBefore( debugTemplate, null ); 
    }
    ////// Redirect to confirmation page. 
    redirectURL = "entry/AddOneItemEdit.po" ; // TODO: Check redirectURL. Should include path from presentation/.
    throw new ClientPageRedirectException( comms.request.getAppFileURIPath( redirectURL ) );   }
}
