package timesheet.presentation.maintenance;

import java.util.*;
// import java.net.URLEncoder;
import org.w3c.dom.*;
import org.w3c.dom.html.*;
import com.lutris.util.*;
import com.lutris.xml.xmlc.*;
import com.lutris.appserver.server.ApplicationException;
import com.lutris.appserver.server.sql.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.pisoftware.platypus.production.*;
import timesheet.presentation.*; 
import timesheet.presentation.maintenance.*; 
import timesheet.business.*; 
import timesheet.business.maintenance.*; 
import timesheet.data.*; 
import timesheet.util.*; 

/** 
 * Class EditPersonForm manipulates the DOM
 * model created by class EditPersonForm. 
 * 
 * TO DO: More detailed doco on what this class does.
 * 
 * Generated by Platypus version 1.0.
 **/

public class EditPersonForm extends EditPersonFormBASE{


  //////  Miscellaneous variables for presentation object
  // Query string and database variables are in a lower section.

  //////  Variables for the query string values
  ////  Form  'MainForm' in 'maintenance.EditPersonList' PO invokes URL  'null'

  /** Value of 'PersonId' on query string, from MainForm form on editPersonForm PO **/
  String qsPersonId ; 

  //////  Variables for database query.

  //////  Declarations for DB query for PersonTable

  /** Count of records returned by PersonTable DB query. **/
  int countPersonTable ;

  /** Clone of prototype node, after prototype is filled with data. **/
  Node newPersonTable ; 

  // /** List of ID nodes in a cloned access tree. **/
  // Hashtable idnodesPersonTable ; 


  /** ID CompanyId from DB query on PersonTable **/
  String fieldCompanyId ; 

  /** ID FirstName from DB query on PersonTable **/
  String fieldFirstName ; 

  /** ID AuthorisationLevel from DB query on PersonTable **/
  String fieldAuthorisationLevel ; 

  /** ID Title from DB query on PersonTable **/
  String fieldTitle ; 

  /** ID PublicPassword from DB query on PersonTable **/
  String fieldPublicPassword ; 

  /** ID Phone from DB query on PersonTable **/
  String fieldPhone ; 

  /** ID Surname from DB query on PersonTable **/
  String fieldSurname ; 

  /** ID Type from DB query on PersonTable **/
  String fieldType ; 

  /** ID UserName from DB query on PersonTable **/
  String fieldUserName ; 

  /** ID Email from DB query on PersonTable **/
  String fieldEmail ; 

  /** ID PersonId from DB query on PersonTable **/
  String fieldPersonId ; 

  /** ID Fax from DB query on PersonTable **/
  String fieldFax ; 

  // End of database field declarations section. 


  /** 
   * Does the actual manipulation of the DOM data structure. 
   * 
   * It defines the abstract method in EditPersonFormBASE.java.  
   * 
   * @exception ApplicationException
   * @exception HttpPresentationException
   **/
  public void manipulate() throws ApplicationException, HttpPresentationException {

    //////  Initialise
    bo = new EditPersonFormBO( comms ); // Do not delete. May do user authentification, etc.
    //// Set DEBUG flag
    DEBUG = false ; 
    if( ProdUtil.nameInQueryString( args, "DEBUG" ) ) DEBUG = true ; 
    if( ProdUtil.sessionDebugFlag( debugData ) ) DEBUG = true ; 

    //////  Get values from query string 
    qsPersonId = ProdUtil.getFromQueryString( args, "PersonId" );

    // DBG
    ProdUtil.log( "Query string pair: 'PersonId' = '" + qsPersonId + "'" );


    //////  Fill dynamic nodes

    
        ////////  Get field values from a PersonTable record

        ////  In access PersonTable, processing ID CompanyId
        fieldCompanyId = bo.getIdValue( /*TODO: Check record selector*/ qsPersonId, "CompanyId", "" ); 
        fieldCompanyId = ProdUtil.cleanString( fieldCompanyId, false ); 
        ProdUtil.drainSelect( protoCompanyId, "CompanyId" ); // TODO: Really delete all OPTIONS?
        ProdUtil.fillSelect( protoCompanyId, "CompanyId", bo.getPulldownItems( "CompanyId" ), fieldCompanyId ); 

        ////  In access PersonTable, processing ID FirstName
        fieldFirstName = bo.getIdValue( /*TODO: Check record selector*/ qsPersonId, "FirstName", "" ); 
        fieldFirstName = ProdUtil.cleanString( fieldFirstName, false ); 
        protoFirstName.setAttribute( "value", fieldFirstName ); 

        ////  In access PersonTable, processing ID AuthorisationLevel
        fieldAuthorisationLevel = bo.getIdValue( /*TODO: Check record selector*/ qsPersonId, "AuthorisationLevel", "" ); 
        fieldAuthorisationLevel = ProdUtil.cleanString( fieldAuthorisationLevel, false ); 
        ProdUtil.drainSelect( protoAuthorisationLevel, "AuthorisationLevel" ); // TODO: Really delete all OPTIONS?
        ProdUtil.fillSelect( protoAuthorisationLevel, "AuthorisationLevel", bo.getPulldownItems( "AuthorisationLevel" ), fieldAuthorisationLevel ); 

        ////  In access PersonTable, processing ID Title
        fieldTitle = bo.getIdValue( /*TODO: Check record selector*/ qsPersonId, "Title", "" ); 
        fieldTitle = ProdUtil.cleanString( fieldTitle, false ); 
        ProdUtil.drainSelect( protoTitle, "Title" ); // TODO: Really delete all OPTIONS?
        ProdUtil.fillSelect( protoTitle, "Title", bo.getPulldownItems( "Title" ), fieldTitle ); 

        ////  In access PersonTable, processing ID PublicPassword
        fieldPublicPassword = bo.getIdValue( /*TODO: Check record selector*/ qsPersonId, "PublicPassword", "" ); 
        fieldPublicPassword = ProdUtil.cleanString( fieldPublicPassword, false ); 
        protoPublicPassword.setAttribute( "value", fieldPublicPassword ); 

        ////  In access PersonTable, processing ID Phone
        fieldPhone = bo.getIdValue( /*TODO: Check record selector*/ qsPersonId, "Phone", "" ); 
        fieldPhone = ProdUtil.cleanString( fieldPhone, false ); 
        protoPhone.setAttribute( "value", fieldPhone ); 

        ////  In access PersonTable, processing ID Surname
        fieldSurname = bo.getIdValue( /*TODO: Check record selector*/ qsPersonId, "Surname", "" ); 
        fieldSurname = ProdUtil.cleanString( fieldSurname, false ); 
        protoSurname.setAttribute( "value", fieldSurname ); 

        ////  In access PersonTable, processing ID Type
        fieldType = bo.getIdValue( /*TODO: Check record selector*/ qsPersonId, "Type", "" ); 
        fieldType = ProdUtil.cleanString( fieldType, false ); 
        protoType.setAttribute( "value", fieldType ); 

        ////  In access PersonTable, processing ID UserName
        fieldUserName = bo.getIdValue( /*TODO: Check record selector*/ qsPersonId, "UserName", "" ); 
        fieldUserName = ProdUtil.cleanString( fieldUserName, false ); 
        protoUserName.setAttribute( "value", fieldUserName ); 

        ////  In access PersonTable, processing ID Email
        fieldEmail = bo.getIdValue( /*TODO: Check record selector*/ qsPersonId, "Email", "" ); 
        fieldEmail = ProdUtil.cleanString( fieldEmail, false ); 
        protoEmail.setAttribute( "value", fieldEmail ); 

        ////  In access PersonTable, processing ID PersonId
        fieldPersonId = bo.getIdValue( /*TODO: Check record selector*/ qsPersonId, "PersonId", "" ); 
        fieldPersonId = ProdUtil.cleanString( fieldPersonId, false ); 
        protoPersonId.setAttribute( "value", fieldPersonId ); 

        ////  In access PersonTable, processing ID Fax
        fieldFax = bo.getIdValue( /*TODO: Check record selector*/ qsPersonId, "Fax", "" ); 
        fieldFax = ProdUtil.cleanString( fieldFax, false ); 
        protoFax.setAttribute( "value", fieldFax ); 



    //////  Restoring FORMS, if necessary
    if( ProdUtil.nameInQueryString( args, "RESTOREQUERYSTRING" ) ){ 
      ProdUtil.restoreFormsFromPresentationData( document, presentationData ); 
    }

    //////  Generate debugging information, if requested.
    if( DEBUG ){ 
      HTMLElement debugTemplate ; 
      //// Fill in debugging information
      debugTemplate = startDebugTemplate(); // Method is in BASE class.
      //// Insert debugging information into DOM tree.
      HTMLBodyElement bodyElement = ProdUtil.getBodyElement( document ); 
      bodyElement.insertBefore( debugTemplate, null ); 
    }
  }
}
