#
# timesheet
# Platypus/Enhydra Application Makefile Configuration
#
#

#
# The directory containing the Enhydra distribution.
#
ENHYDRA_DIR = /usr/local/enhydra


#
# The directory containing the XMLC distribution.
#
XMLC_DIR = /usr/local/XMLC


#
# You might want to change/override some of the following variables:
#
# Is JDKDIR correct?
JDKDIR = /usr/local/java
#
# Is PLATYPUSDIR correct?
PLATYPUSDIR = /usr/local/platypus
#
# Is ENHYDRA_CLASSES correct?
ENHYDRA_CLASSES = $(ENHYDRA_DIR)/output/lib/enhydra.jar
#
# Is XMLC correct?
XMLC = $(XMLC_DIR)/output/bin/xmlc
#
# Is JOLTC correct?
JOLTC = $(ENHYDRA_DIR)/output/bin/joltc
#
# See $(PLATYPUSDIR)/stdrules.mk in the Platypus installation for more
# configuration settings.
#


#
APP_NAME = timesheet
APP_DIR = $(shell echo $(APP_NAME) | tr . /)
GEN_DIR = $(ROOT)/$(APP_DIR)
SRC_DIR = $(ROOT)/src
CLASS_DIR = $(ROOT)/classes/$(APP_DIR)
VIEW_DIR = $(ROOT)/view
HTML_XMLC_OPTS_FILE = $(ROOT)/config.xmlc

# NOTE: Some rules in stdrules.mk have HTML_XMLC_OPTS_FILE as a
# prerequisite. If it isn't defined, their targets will always be 'out
# of date'!

JAVADOCFLAGS = -private -author -version

# Extra classpath information required
XTRA_CLASSPATH=$(PLATYPUSDIR)/output/lib/platypus.jar:$(XMLC_DIR)/output/lib/xmlc.jar

#
# What is the name of the jar file to create?
#
JARNAME = timesheet

#
# Include the special platypus rules
#
include $(PLATYPUSDIR)/stdrules.mk

#
# Only used if ENHYDRA_DIR is not correct.
#
$(ROOT)/stdrules.mk:
	@echo
	@echo "Please edit config.mk. ENHYDRA_DIR must point to your installation of Enhydra."
	@echo
