/* This SQL was generated for a PostgreSQL database. */

create table t_project
(
/* class Project */
Name VARCHAR(255)  UNIQUE NOT NULL   ,
CompanyId INT8   NOT NULL  REFERENCES t_company(objectID) ,
Status VARCHAR(255) DEFAULT 'Active'  NOT NULL   ,
OutstandingWorkState BOOL DEFAULT true  NOT NULL   ,
DevelopmentURL VARCHAR(255)      ,
ProductionURL VARCHAR(255)      ,
CurrentVersion VARCHAR(255) DEFAULT 'Alpha 0.0'     ,
AdditionalContactDetails VARCHAR(255)      ,
DevelopmentDirectory VARCHAR(255)      ,
ProductionDirectory VARCHAR(255)      ,
SuppliedContentDirectory VARCHAR(255)      ,
BaseDirectory VARCHAR(255)      ,
PurchaseHistoryFile VARCHAR(255)      ,
Relationship VARCHAR(255)      ,
ServiceLevelAgreementFile VARCHAR(255)      ,
OutstandingWorkInformationFile VARCHAR(255)      ,
NotesFile VARCHAR(255)      ,

    /* NOTICE: */
    /* This table represents a Data Object class  */
    /* derived from dods.builder.sourceGenerators.DO.GenericDO. */
    /* The class GenericDO contains: */
    /* 1) an ObjectId (objectID)     which is stored as a DECIMAL(19,0) */
    /* 2) an int      (objectVersion) which is stored as an INTEGER */
    /* When creating Data Objects in DODS, these two columns */
    /* (a.k.a class members, Data Object Attributes) */
    /* should never be defined explicitly. */

    /* These columns are defined here at the end of the */
    /* CREATE TABLE statement to simplify the handling of commas. */
    objectID INT8 NOT NULL PRIMARY KEY,
    objectVersion INT4 NOT NULL

);

CREATE INDEX I1_t_project ON t_project(Name);
CREATE INDEX I2_t_project ON t_project(CompanyId);
CREATE INDEX I3_t_project ON t_project(Status);

