package timesheet.business;

import timesheet.*;
import timesheet.data.*;
import java.util.*;
import com.lutris.appserver.server.*;
import com.lutris.appserver.server.sql.*;
import com.lutris.dods.builder.sourceGenerators.Query.*;
import java.sql.*;
import java.math.*;
import com.pisoftware.platypus.production.*;


/**
 * Date Created: Oct 22, 1999
 * <P>
 * Purpose:  This class provides the business logic associated with
 *           a Person.  It should probably be used by other BOs only.
 *
 */
public class PersonBO extends PersonBDO {


/**
 * Constructor.  Creates the object, and initialises the
 * appropriate variables, etc.
 * 
 * @exception Exception thrown by BDO constructor.  :-(
 */
  public PersonBO() throws Exception {

    super();

  }



/*
 * Start of getIdValue Methods
*/

  private PersonDO[] query_results = null;


/**
 * Sets the query results to be used in the getIdValue
 * method calls.
 *
 * @param results  The results to use
 */
  public void setQueryResults(PersonDO[] results) {

    this.query_results = results;

  }


/**
 * Gets the current query results being used in the getIdValue
 * method calls.
 *
 * @return see comment
 */
  public PersonDO[] getQueryResults() {

    return this.query_results;

  }


/**
 * Gets information from the DO layer for the ID passed.
 * Note that a previous ACCESS method must have been
 * called for this function to work.
 *
 * @param index  The record to use
 * @param id  The id who's value is to be returned.
 * @param format  Determines what formatting is required for the id's value
 * @return A String representing the value retrieved.
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public String getIdValue(int index, String id, String format) throws ApplicationException {

    if (query_results == null) {

      throw new ApplicationException("No query results to obtain data from!");

    }

    String result_str = "";
    boolean id_found = false;

      if (id.equalsIgnoreCase("FirstName")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for FirstName.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    String result;

    try {

      result = query_results[index].getFirstName();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for FirstName", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("AuthorisationLevel")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for AuthorisationLevel.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    String result;

    try {

      result = query_results[index].getAuthorisationLevel();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for AuthorisationLevel", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("Title")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for Title.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    String result;

    try {

      result = query_results[index].getTitle();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for Title", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("PublicPassword")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for PublicPassword.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    String result;

    try {

      result = query_results[index].getPublicPassword();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for PublicPassword", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("Phone")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for Phone.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    String result;

    try {

      result = query_results[index].getPhone();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for Phone", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("Surname")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for Surname.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    String result;

    try {

      result = query_results[index].getSurname();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for Surname", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("Type")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for Type.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    String result;

    try {

      result = query_results[index].getType();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for Type", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("UserName")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for UserName.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    String result;

    try {

      result = query_results[index].getUserName();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for UserName", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("Email")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for Email.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    String result;

    try {

      result = query_results[index].getEmail();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for Email", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("CompanyName")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for CompanyName.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    String result;

    try {

      result = query_results[index].getCompanyId().getName();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for CompanyName", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("Fax")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for Fax.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    String result;

    try {

      result = query_results[index].getFax();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for Fax", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("ObjectId")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for ObjectId.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    java.math.BigDecimal result;

    try {

      result = query_results[index].getOId().toBigDecimal();

    } catch (Exception doe) {

      throw new ApplicationException("Unable to obtain data for ObjectId", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("CompanyId")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for CompanyId.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    java.math.BigDecimal result;

    try {

      result = query_results[index].getCompanyId().getOId().toBigDecimal();

    } catch (Exception doe) {

      throw new ApplicationException("Unable to obtain data for CompanyId", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("PersonId")) {

    id_found = true;

    
    // ensure we've got something to get data from
    if (query_results == null || query_results.length == 0)
      throw new ApplicationException("Unable to obtain data for PersonId.  No data available from query");

    if (index < 0 || index > query_results.length -1)
      throw new ApplicationException("Invalid index to obtain data from query: "+index);


    java.math.BigDecimal result;

    try {

      result = query_results[index].getOId().toBigDecimal();

    } catch (Exception doe) {

      throw new ApplicationException("Unable to obtain data for PersonId", doe);

    }

    result_str = FormatUtil.format(result, format);

  }


    // was the id found?
    if (!id_found) {

      // no, return a value with the details passed
      return "ID Value passed: "+id+", index is: "+index+", format is: "+format;

    } else {

      // return the formatted result
      return result_str;

    }

  }


  // psuedo-cache to speed access to the db data.
  private java.math.BigDecimal oid = null;


/**
 * Gets information from the DO layer for the ID passed.
 *
 * @param oidstr  The database oid for the record
 * @param id  The id who's value is to be returned.
 * @param format  Determines what formatting is required for the id's value
 * @return A String representing the value retrieved.
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public String getIdValue(String oidstr, String id, String format) throws ApplicationException {

    String result_str = "";
    boolean id_found = false;

    try {

      // are we accesing the same oid again?
      if (DO == null || !oidstr.equals(DO.getHandle().toString())) {

        // no - get this oid's DO from the db.

        oid = new java.math.BigDecimal(oidstr);
        DO = PersonDO.createExisting(oid);

      }

    } catch (Exception e) {

      throw new ApplicationException("Unable to obtain value for id: "+id+" using this ObjectId: "+oidstr, e);

    }

      if (id.equalsIgnoreCase("FirstName")) {

    id_found = true;

    

    String result;

    try {

      result = DO.getFirstName();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for FirstName", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("AuthorisationLevel")) {

    id_found = true;

    

    String result;

    try {

      result = DO.getAuthorisationLevel();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for AuthorisationLevel", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("Title")) {

    id_found = true;

    

    String result;

    try {

      result = DO.getTitle();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for Title", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("PublicPassword")) {

    id_found = true;

    

    String result;

    try {

      result = DO.getPublicPassword();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for PublicPassword", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("Phone")) {

    id_found = true;

    

    String result;

    try {

      result = DO.getPhone();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for Phone", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("Surname")) {

    id_found = true;

    

    String result;

    try {

      result = DO.getSurname();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for Surname", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("Type")) {

    id_found = true;

    

    String result;

    try {

      result = DO.getType();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for Type", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("UserName")) {

    id_found = true;

    

    String result;

    try {

      result = DO.getUserName();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for UserName", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("Email")) {

    id_found = true;

    

    String result;

    try {

      result = DO.getEmail();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for Email", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("CompanyName")) {

    id_found = true;

    

    String result;

    try {

      result = DO.getCompanyId().getName();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for CompanyName", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("Fax")) {

    id_found = true;

    

    String result;

    try {

      result = DO.getFax();

    } catch (DataObjectException doe) {

      throw new ApplicationException("Unable to obtain data for Fax", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("ObjectId")) {

    id_found = true;

    

    java.math.BigDecimal result;

    try {

      result = DO.getOId().toBigDecimal();

    } catch (Exception doe) {

      throw new ApplicationException("Unable to obtain data for ObjectId", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("CompanyId")) {

    id_found = true;

    

    java.math.BigDecimal result;

    try {

      result = DO.getCompanyId().getOId().toBigDecimal();

    } catch (Exception doe) {

      throw new ApplicationException("Unable to obtain data for CompanyId", doe);

    }

    result_str = FormatUtil.format(result, format);

  }
 else  if (id.equalsIgnoreCase("PersonId")) {

    id_found = true;

    

    java.math.BigDecimal result;

    try {

      result = DO.getOId().toBigDecimal();

    } catch (Exception doe) {

      throw new ApplicationException("Unable to obtain data for PersonId", doe);

    }

    result_str = FormatUtil.format(result, format);

  }


    // was the id found?
    if (!id_found) {

      // no, return a value with the details passed
      return "ID Value passed: "+id+", oidstr is: "+oidstr+", format is: "+format;

    } else {

      // return the formatted result
      return result_str;

    }

  }



/*
 * End of getIdValue Methods
*/




}

