package timesheet.business.entry;

import com.lutris.appserver.server.*;
import com.lutris.appserver.server.sql.*;
import com.lutris.appserver.server.httpPresentation.*;
import timesheet.*;
import timesheet.data.*;
import timesheet.business.*;
import java.util.*;
import com.lutris.dods.builder.sourceGenerators.Query.*;
import com.pisoftware.platypus.production.*;

/**
 * Date Created: Oct 22, 1999
 *<P>
 * Purpose: This class is a BO for the EditWorkItemsForm PO.  
 *
 */
public class EditWorkItemsFormBO extends EntryBO {


/**
 * Constructor.  Creates the object, and initialises the appropriate variables, etc.
 *
 * @param comms  Used to get the session data required
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public EditWorkItemsFormBO(HttpPresentationComms comms) throws ApplicationException {

    super(comms);

  }
    
   
/**   
 * Returns the list of pulldown items for the name passed.
 *  
 * @param pulldown_name  The Pulldown name to query for
 * @return an array of PulldownDOs containing the list of values for this pulldown name, null or empty array if none found.
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */   
  public PulldownItem[] getPulldownItems(String pulldown_name) throws ApplicationException {

    /*
     * Add your code here if you want to override/add pulldown item(s).
     */
  
    return super.getPulldownItems(pulldown_name);

  }



/*
 * Start of Access Methods
*/

  private TimeEntryDO[] TimeEntryTable = null;



/**
 * getTimeEntryTable: Query method for use by the PO layer.
 * 
 * @param qsFromDate Parameter supplied by PO
 * @param qsToDate Parameter supplied by PO
 * @return The number of records found.
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public int getTimeEntryTable(String qsFromDate, String qsToDate) throws ApplicationException {

    /*
     * Insert your code to do your query.  Put the result into
     * the variable TimeEntryTable as defined above.  getIdValue
     * will use the TimeEntryTable where appropriate.
     *
     */
   
    // determine the number of records found
    return (TimeEntryTable == null) ? 0 : TimeEntryTable.length;  

  }



/*
 * End of Access Methods
*/



/*
  No Commit Method(s) Generated!
*/


/*
 * Start of getIdValue Methods
*/


/**
 * Gets information from the DO layer for the ID passed.
 * Note that a previous ACCESS method must have been
 * called for this function to work.
 *
 * @param index  The record to use
 * @param id  The id who's value is to be returned.
 * @param format  Determines what formatting is required for the id's value
 * @return A String representing the value retrieved.
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public String getIdValue(int index, String id, String format) throws ApplicationException {

    String result_str = "";
    boolean id_found = false;

      if (id.equalsIgnoreCase("DayDate1")) {

    id_found = true;

    timeEntryBO.setQueryResults(TimeEntryTable);

    result_str = timeEntryBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("TimeEntryId")) {

    id_found = true;

    timeEntryBO.setQueryResults(TimeEntryTable);

    result_str = timeEntryBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("DayDate")) {

    id_found = true;

    timeEntryBO.setQueryResults(TimeEntryTable);

    result_str = timeEntryBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("ActivityId")) {

    id_found = true;

    timeEntryBO.setQueryResults(TimeEntryTable);

    result_str = timeEntryBO.getIdValue(index, id, format);

  }
 else if (id.equalsIgnoreCase("DayHeader")) {
 /* TODO: HANDLE THIS ID!!! */
}  else  if (id.equalsIgnoreCase("ProjectId")) {

    id_found = true;

    timeEntryBO.setQueryResults(TimeEntryTable);

    result_str = timeEntryBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("Details")) {

    id_found = true;

    timeEntryBO.setQueryResults(TimeEntryTable);

    result_str = timeEntryBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("NrHours")) {

    id_found = true;

    timeEntryBO.setQueryResults(TimeEntryTable);

    result_str = timeEntryBO.getIdValue(index, id, format);

  }


    // did we get some data?
    if (!id_found) {

      // no - try our parent, it might know better...
      result_str = super.getIdValue(index, id, format);

    }

    return result_str;

  }


/**
 * Gets information from the DO layer for the ID passed.
 *
 * @param oidstr  The database oid for the record
 * @param id  The id who's value is to be returned.
 * @param format  Determines what formatting is required for the id's value
 * @return A String representing the value retrieved.
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public String getIdValue(String oidstr, String id, String format) throws ApplicationException {

    String result_str = "";
    boolean id_found = false;

      if (id.equalsIgnoreCase("DayDate1")) {

    id_found = true;

     

    result_str = timeEntryBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("TimeEntryId")) {

    id_found = true;

     

    result_str = timeEntryBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("DayDate")) {

    id_found = true;

     

    result_str = timeEntryBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("ActivityId")) {

    id_found = true;

     

    result_str = timeEntryBO.getIdValue(oidstr, id, format);

  }
 else if (id.equalsIgnoreCase("DayHeader")) {
 /* TODO: HANDLE THIS ID!!! */
}  else  if (id.equalsIgnoreCase("ProjectId")) {

    id_found = true;

     

    result_str = timeEntryBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("Details")) {

    id_found = true;

     

    result_str = timeEntryBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("NrHours")) {

    id_found = true;

     

    result_str = timeEntryBO.getIdValue(oidstr, id, format);

  }


    // did we get some data?
    if (!id_found) {

      // no - try our parent, it might know better...
      result_str = super.getIdValue(oidstr, id, format);

    }

    return result_str;

  }



/*
 * End of getIdValue Methods
*/



/*
  No getBusinessIdValue Method Generated!
*/

}

