package timesheet.business.maintenance;

import com.lutris.appserver.server.*;
import com.lutris.appserver.server.sql.*;
import com.lutris.appserver.server.httpPresentation.*;
import timesheet.*;
import timesheet.data.*;
import timesheet.business.*;
import java.util.*;
import com.lutris.dods.builder.sourceGenerators.Query.*;
import com.pisoftware.platypus.production.*;

/**
 * Date Created: Oct 22, 1999
 *<P>
 * Purpose: This class is a BO for the EditPersonForm PO.  
 *
 */
public class EditPersonFormBO extends MaintenanceBO {


/**
 * Constructor.  Creates the object, and initialises the appropriate variables, etc.
 *
 * @param comms  Used to get the session data required
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public EditPersonFormBO(HttpPresentationComms comms) throws ApplicationException {

    super(comms);

  }
    
   
/**   
 * Returns the list of pulldown items for the name passed.
 *  
 * @param pulldown_name  The Pulldown name to query for
 * @return an array of PulldownDOs containing the list of values for this pulldown name, null or empty array if none found.
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */   
  public PulldownItem[] getPulldownItems(String pulldown_name) throws ApplicationException {

    /*
     * Add your code here if you want to override/add pulldown item(s).
     */
  
    return super.getPulldownItems(pulldown_name);

  }



/*
 * Start of Access Methods
*/

  private PersonDO[] PersonTable = null;



/**
 * getPersonTable: Query method for use by the PO layer.
 * 
 * @param qsPersonId Parameter supplied by PO
 * @return The number of records found.
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public int getPersonTable(String qsPersonId) throws ApplicationException {

    /*
     * Insert your code to do your query.  Put the result into
     * the variable PersonTable as defined above.  getIdValue
     * will use the PersonTable where appropriate.
     *
     */
   
    // determine the number of records found
    return (PersonTable == null) ? 0 : PersonTable.length;  

  }



/*
 * End of Access Methods
*/



/*
  No Commit Method(s) Generated!
*/


/*
 * Start of getIdValue Methods
*/


/**
 * Gets information from the DO layer for the ID passed.
 * Note that a previous ACCESS method must have been
 * called for this function to work.
 *
 * @param index  The record to use
 * @param id  The id who's value is to be returned.
 * @param format  Determines what formatting is required for the id's value
 * @return A String representing the value retrieved.
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public String getIdValue(int index, String id, String format) throws ApplicationException {

    String result_str = "";
    boolean id_found = false;

      if (id.equalsIgnoreCase("CompanyId")) {

    id_found = true;

    personBO.setQueryResults(PersonTable);

    result_str = personBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("FirstName")) {

    id_found = true;

    personBO.setQueryResults(PersonTable);

    result_str = personBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("AuthorisationLevel")) {

    id_found = true;

    personBO.setQueryResults(PersonTable);

    result_str = personBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("Title")) {

    id_found = true;

    personBO.setQueryResults(PersonTable);

    result_str = personBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("PublicPassword")) {

    id_found = true;

    personBO.setQueryResults(PersonTable);

    result_str = personBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("Phone")) {

    id_found = true;

    personBO.setQueryResults(PersonTable);

    result_str = personBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("Surname")) {

    id_found = true;

    personBO.setQueryResults(PersonTable);

    result_str = personBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("Type")) {

    id_found = true;

    personBO.setQueryResults(PersonTable);

    result_str = personBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("UserName")) {

    id_found = true;

    personBO.setQueryResults(PersonTable);

    result_str = personBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("Email")) {

    id_found = true;

    personBO.setQueryResults(PersonTable);

    result_str = personBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("PersonId")) {

    id_found = true;

    personBO.setQueryResults(PersonTable);

    result_str = personBO.getIdValue(index, id, format);

  }
 else  if (id.equalsIgnoreCase("Fax")) {

    id_found = true;

    personBO.setQueryResults(PersonTable);

    result_str = personBO.getIdValue(index, id, format);

  }


    // did we get some data?
    if (!id_found) {

      // no - try our parent, it might know better...
      result_str = super.getIdValue(index, id, format);

    }

    return result_str;

  }


/**
 * Gets information from the DO layer for the ID passed.
 *
 * @param oidstr  The database oid for the record
 * @param id  The id who's value is to be returned.
 * @param format  Determines what formatting is required for the id's value
 * @return A String representing the value retrieved.
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public String getIdValue(String oidstr, String id, String format) throws ApplicationException {

    String result_str = "";
    boolean id_found = false;

      if (id.equalsIgnoreCase("CompanyId")) {

    id_found = true;

     

    result_str = personBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("FirstName")) {

    id_found = true;

     

    result_str = personBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("AuthorisationLevel")) {

    id_found = true;

     

    result_str = personBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("Title")) {

    id_found = true;

     

    result_str = personBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("PublicPassword")) {

    id_found = true;

     

    result_str = personBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("Phone")) {

    id_found = true;

     

    result_str = personBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("Surname")) {

    id_found = true;

     

    result_str = personBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("Type")) {

    id_found = true;

     

    result_str = personBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("UserName")) {

    id_found = true;

     

    result_str = personBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("Email")) {

    id_found = true;

     

    result_str = personBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("PersonId")) {

    id_found = true;

     

    result_str = personBO.getIdValue(oidstr, id, format);

  }
 else  if (id.equalsIgnoreCase("Fax")) {

    id_found = true;

     

    result_str = personBO.getIdValue(oidstr, id, format);

  }


    // did we get some data?
    if (!id_found) {

      // no - try our parent, it might know better...
      result_str = super.getIdValue(oidstr, id, format);

    }

    return result_str;

  }



/*
 * End of getIdValue Methods
*/



/*
  No getBusinessIdValue Method Generated!
*/

}

