/* This SQL was generated for a PostgreSQL database. */

create table t_person
(
/* class Person */
CompanyId INT8   NOT NULL  REFERENCES t_company(objectID) ,
FirstName VARCHAR(255)   NOT NULL   ,
Surname VARCHAR(255)   NOT NULL   ,
Title VARCHAR(255)      ,
Email VARCHAR(255)      ,
Phone VARCHAR(255)      ,
Fax VARCHAR(255)      ,
Type VARCHAR(255) DEFAULT 'customer'  NOT NULL   ,
AuthorisationLevel VARCHAR(255) DEFAULT 'none'  NOT NULL   ,
PublicPassword VARCHAR(255)      ,
UserName VARCHAR(255) DEFAULT 'none'  NOT NULL   ,

    /* NOTICE: */
    /* This table represents a Data Object class  */
    /* derived from dods.builder.sourceGenerators.DO.GenericDO. */
    /* The class GenericDO contains: */
    /* 1) an ObjectId (objectID)     which is stored as a DECIMAL(19,0) */
    /* 2) an int      (objectVersion) which is stored as an INTEGER */
    /* When creating Data Objects in DODS, these two columns */
    /* (a.k.a class members, Data Object Attributes) */
    /* should never be defined explicitly. */

    /* These columns are defined here at the end of the */
    /* CREATE TABLE statement to simplify the handling of commas. */
    objectID INT8 NOT NULL PRIMARY KEY,
    objectVersion INT4 NOT NULL

);

CREATE INDEX I1_t_person ON t_person(CompanyId);
CREATE INDEX I2_t_person ON t_person(Surname);
CREATE INDEX I3_t_person ON t_person(Type);
CREATE INDEX I4_t_person ON t_person(UserName);

