package timesheet.presentation.maintenance;

import java.util.*;
// import java.net.URLEncoder;
import org.w3c.dom.*;
import org.w3c.dom.html.*;
import com.lutris.util.*;
import com.lutris.xml.xmlc.*;
import com.lutris.appserver.server.ApplicationException;
import com.lutris.appserver.server.sql.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.pisoftware.platypus.production.*;
import timesheet.presentation.*; 
import timesheet.presentation.maintenance.*; 
import timesheet.business.*; 
import timesheet.business.maintenance.*; 
import timesheet.data.*; 
import timesheet.util.*; 

/** 
 * Class AddPersonCommit manipulates the DOM
 * model created by class AddPersonCommit. 
 * 
 * TO DO: More detailed doco on what this class does.
 * 
 * Generated by Platypus version 1.0.
 **/

public class AddPersonCommit extends AddPersonCommitBASE{


  //////  Miscellaneous variables for presentation object
  // Query string and database variables are in a lower section.
  /** URL to which we will redirect the browser, after this class does its work. **/
  String redirectURL ; 
  //////  Variables for the query string values
  ////  Form  'MainForm' in 'maintenance.AddPersonForm' PO invokes URL  'AddPersonCommit.po'

  /** Value of 'CompanyId' on query string, from MainForm form on addPersonCommit PO **/
  String qsCompanyId ; 

  /** Value of 'FirstName' on query string, from MainForm form on addPersonCommit PO **/
  String qsFirstName ; 

  /** Value of 'AuthorisationLevel' on query string, from MainForm form on addPersonCommit PO **/
  String qsAuthorisationLevel ; 

  /** Value of 'Title' on query string, from MainForm form on addPersonCommit PO **/
  String qsTitle ; 

  /** Value of 'PublicPassword' on query string, from MainForm form on addPersonCommit PO **/
  String qsPublicPassword ; 

  /** Value of 'Phone' on query string, from MainForm form on addPersonCommit PO **/
  String qsPhone ; 

  /** Value of 'Surname' on query string, from MainForm form on addPersonCommit PO **/
  String qsSurname ; 

  /** Value of '_noattr' on query string, from MainForm form on addPersonCommit PO **/
  String qs_noattr ; 

  /** Value of 'Type' on query string, from MainForm form on addPersonCommit PO **/
  String qsType ; 

  /** Value of 'UserName' on query string, from MainForm form on addPersonCommit PO **/
  String qsUserName ; 

  /** Value of 'Email' on query string, from MainForm form on addPersonCommit PO **/
  String qsEmail ; 

  /** Value of 'Fax' on query string, from MainForm form on addPersonCommit PO **/
  String qsFax ; 
  ////  Form  'MainForm' in 'maintenance.EditPersonForm' PO invokes URL  'AddPersonCommit.po'

  /** Value of 'PersonId' on query string, from MainForm form on addPersonCommit PO **/
  String qsPersonId ; 

  //////  Variables for database query.

  // End of database field declarations section. 


  /** 
   * Does the actual manipulation of the DOM data structure. 
   * 
   * It defines the abstract method in AddPersonCommitBASE.java.  
   * 
   * @exception ApplicationException
   * @exception HttpPresentationException
   **/
  public void manipulate() throws ApplicationException, HttpPresentationException {

    //////  Initialise
    bo = new AddPersonCommitBO( comms ); // Do not delete. May do user authentification, etc.
    //// Set DEBUG flag
    DEBUG = false ; 
    if( ProdUtil.nameInQueryString( args, "DEBUG" ) ) DEBUG = true ; 
    if( ProdUtil.sessionDebugFlag( debugData ) ) DEBUG = true ; 

    //////  Get values from query string 
    qsCompanyId = ProdUtil.getFromQueryString( args, "CompanyId" );
    qsFirstName = ProdUtil.getFromQueryString( args, "FirstName" );
    qsAuthorisationLevel = ProdUtil.getFromQueryString( args, "AuthorisationLevel" );
    qsTitle = ProdUtil.getFromQueryString( args, "Title" );
    qsPublicPassword = ProdUtil.getFromQueryString( args, "PublicPassword" );
    qsPhone = ProdUtil.getFromQueryString( args, "Phone" );
    qsSurname = ProdUtil.getFromQueryString( args, "Surname" );
    qs_noattr = ProdUtil.getFromQueryString( args, "_noattr" );
    qsType = ProdUtil.getFromQueryString( args, "Type" );
    qsUserName = ProdUtil.getFromQueryString( args, "UserName" );
    qsEmail = ProdUtil.getFromQueryString( args, "Email" );
    qsFax = ProdUtil.getFromQueryString( args, "Fax" );
    qsPersonId = ProdUtil.getFromQueryString( args, "PersonId" );

    // DBG
    ProdUtil.log( "Query string pair: 'CompanyId' = '" + qsCompanyId + "'" );
    ProdUtil.log( "Query string pair: 'FirstName' = '" + qsFirstName + "'" );
    ProdUtil.log( "Query string pair: 'AuthorisationLevel' = '" + qsAuthorisationLevel + "'" );
    ProdUtil.log( "Query string pair: 'Title' = '" + qsTitle + "'" );
    ProdUtil.log( "Query string pair: 'PublicPassword' = '" + qsPublicPassword + "'" );
    ProdUtil.log( "Query string pair: 'Phone' = '" + qsPhone + "'" );
    ProdUtil.log( "Query string pair: 'Surname' = '" + qsSurname + "'" );
    ProdUtil.log( "Query string pair: '_noattr' = '" + qs_noattr + "'" );
    ProdUtil.log( "Query string pair: 'Type' = '" + qsType + "'" );
    ProdUtil.log( "Query string pair: 'UserName' = '" + qsUserName + "'" );
    ProdUtil.log( "Query string pair: 'Email' = '" + qsEmail + "'" );
    ProdUtil.log( "Query string pair: 'Fax' = '" + qsFax + "'" );
    ProdUtil.log( "Query string pair: 'PersonId' = '" + qsPersonId + "'" );


    //////  Database add for AddPerson
    String oidAddPerson ; // ObjectId for new/updated record
    try{ 
      // Note: commitAddPerson() args must be consistent with BO code. 
      // Edit the conf file rather than java code. 
      oidAddPerson = bo.commitAddPerson( qsAuthorisationLevel, qsCompanyId, qsEmail, qsFax, qsFirstName, qsPhone, qsPublicPassword, qsSurname, qsTitle, qsType, qsUserName ); 
    }catch( UserDuplicateRecordException udre ){ 
      try{ 
        presentationData.set( "RESTOREQUERYSTRING", args ); 
      }catch( KeywordValueException kve ){ 
        ProdUtil.log( "Failed insert into presentationData: RESTOREQUERYSTRING" ); 
      }
      String backURLPO ; 
      backURLPO = "maintenance/AddPersonForm,maintenance/EditPersonForm" ; // TODO: Check backURLPO is correct. Should be relative PO URL, without suffix.
      udre.backURL = backURLPO + ".po?RESTOREQUERYSTRING=TRUE" ; 
      throw udre ; 
    }
    // DBG
    ProdUtil.log( "oidAddPerson is '" + oidAddPerson + "'" ); 

    //////  Database update for EditPerson
    String oidEditPerson ; // ObjectId for new/updated record
    try{ 
      // Note: commitEditPerson() args must be consistent with BO code. 
      // Edit the conf file rather than java code. 
      oidEditPerson = bo.commitEditPerson( qsPersonId, qsAuthorisationLevel, qsCompanyId, qsEmail, qsFax, qsFirstName, qsPhone, qsPublicPassword, qsSurname, qsTitle, qsType, qsUserName ); 
    }catch( UserDuplicateRecordException udre ){ 
      try{ 
        presentationData.set( "RESTOREQUERYSTRING", args ); 
      }catch( KeywordValueException kve ){ 
        ProdUtil.log( "Failed insert into presentationData: RESTOREQUERYSTRING" ); 
      }
      String backURLPO ; 
      backURLPO = "maintenance/AddPersonForm,maintenance/EditPersonForm" ; // TODO: Check backURLPO is correct. Should be relative PO URL, without suffix.
      udre.backURL = backURLPO + ".po?RESTOREQUERYSTRING=TRUE" ; 
      throw udre ; 
    }
    // DBG
    ProdUtil.log( "oidEditPerson is '" + oidEditPerson + "'" ); 

    //////  Fill dynamic nodes

    //////  Processing ID PersonId
    protoPersonId.setAttribute( "value", qsPersonId ); 

    //////  Restoring FORMS, if necessary
    if( ProdUtil.nameInQueryString( args, "RESTOREQUERYSTRING" ) ){ 
      ProdUtil.restoreFormsFromPresentationData( document, presentationData ); 
    }

    //////  Generate debugging information, if requested.
    if( DEBUG ){ 
      HTMLElement debugTemplate ; 
      //// Fill in debugging information
      debugTemplate = startDebugTemplate(); // Method is in BASE class.
      //// Insert debugging information into DOM tree.
      HTMLBodyElement bodyElement = ProdUtil.getBodyElement( document ); 
      bodyElement.insertBefore( debugTemplate, null ); 
    }
    ////// Redirect to confirmation page. 
    redirectURL = "maintenance/AddPersonResults.po" ; // TODO: Check redirectURL. Should include path from presentation/.
    throw new ClientPageRedirectException( comms.request.getAppFileURIPath( redirectURL ) );   }
}
