package timesheet.business;

import timesheet.*;
import timesheet.data.*;
import java.util.*;
import com.lutris.appserver.server.*;
import com.lutris.appserver.server.sql.*;
import com.lutris.dods.builder.sourceGenerators.Query.*;
import java.sql.*;
import java.math.*;
import com.pisoftware.platypus.production.*;


/**
 * Date Created: Oct 15, 1999
 * <P>
 * Purpose:  This class provides the business logic associated with
 *           a Project.  It should probably be used by other BOs only.
 *
 */
public class ProjectBO extends ProjectBDO {


/**
 * Constructor.  Creates the object, and initialises the
 * appropriate variables, etc.
 * 
 * @exception Exception thrown by BDO constructor.  :-(
 */
  public ProjectBO() throws Exception {

    super();

  }


/*
  No getIdValue Method(s) Generated!
*/


/**
 * getAllProjects: generated by Squirt!
 *
 * <JAVADOC_PARAMETERS>
 * @return an array of ProjectDOs for this query
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public ProjectDO[] getAllProjects() throws ApplicationException {

    ProjectDO[] results = null;
    ProjectQuery query = new ProjectQuery();

    try {

      
      query.addOrderByName(); 

      

      results = query.getDOArray();

    } catch (DataObjectException doe) {

      throw new ApplicationException( "Unable to create existing Project Data Object", doe );

    } catch ( NonUniqueQueryException nuqe ) {

      // ...this exception will only occur is requireUniqueInstance was called.
      throw new ApplicationException( "Non unique result!", nuqe );  

    }

    // return the results found, if any
    return results;

  }


    // 'cache' for query - createExisting can be a time expensive call...
    private String findProject_ObjectId = "";
    private ProjectDO findProject_DO = null;


/**
 * findProject: generated by Squirt!  This query is for
 * finding a record in a table by ObjectId.  The row
 * must be in the table, otherwise an exception will
 * be thrown.
 *
 * @param objectid  The record to retrieve from Project
 * @return an array of ProjectDOs for this query
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public ProjectDO findProject(String objectid) throws ApplicationException {

    // have we just referenced this object id?
    if (objectid.equals(findProject_ObjectId)) {

      // yes, use our cached version
      return findProject_DO;

    }

    ProjectDO result = null;

    try {

      java.math.BigDecimal bd = new java.math.BigDecimal(objectid);
      result = ProjectDO.createExisting(bd);

      // keep details in our cache
      findProject_ObjectId = objectid;
      findProject_DO = result;

    } catch (Exception e) {

      throw new ApplicationException("Unable to create existing Project Data Object", e );

    }

    // return the results found, if any
    return result;

  }



}

