package timesheet.presentation.entry;

import java.util.*;
// import java.net.URLEncoder;
import org.w3c.dom.*;
import org.w3c.dom.html.*;
import com.lutris.util.*;
import com.lutris.xml.xmlc.*;
import com.lutris.appserver.server.ApplicationException;
import com.lutris.appserver.server.sql.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.pisoftware.platypus.production.*;
import timesheet.presentation.*; 
import timesheet.presentation.entry.*; 
import timesheet.business.*; 
import timesheet.business.entry.*; 
import timesheet.data.*; 
import timesheet.util.*; 

/** 
 * Class EditWorkItemsForm manipulates the DOM
 * model created by class EditWorkItemsForm. 
 * 
 * TO DO: More detailed doco on what this class does.
 * 
 * Generated by Platypus version 1.0.
 **/

public class EditWorkItemsForm extends EditWorkItemsFormBASE{


  //////  Miscellaneous variables for presentation object
  // Query string and database variables are in a lower section.

  //////  Variables for the query string values
  ////  Form  'MainForm' in 'entry.EditWorkItemsQuery' PO invokes URL  'EditWorkItemsForm.html'

  /** Value of '_noattr' on query string, from MainForm form on editWorkItemsForm PO **/
  String qs_noattr ; 

  /** Value of 'ToDate' on query string, from MainForm form on editWorkItemsForm PO **/
  String qsToDate ; 

  /** Value of 'FromDate' on query string, from MainForm form on editWorkItemsForm PO **/
  String qsFromDate ; 
  ////  Form  'MainForm' in 'entry.AddOneItemCommit' PO invokes URL  'AddOneItemForm.html'

  /** Value of 'TimeEntryId' on query string, from MainForm form on editWorkItemsForm PO **/
  String qsTimeEntryId ; 

  /** Value of 'EntryDate' on query string, from MainForm form on editWorkItemsForm PO **/
  String qsEntryDate ; 

  //////  Variables for database query.

  //////  Declarations for DB query for TimeEntryTable

  /** Count of records returned by TimeEntryTable DB query. **/
  int countTimeEntryTable ;
  /** Loop index **/
  int iTimeEntryTable ; 

  /** Clone of prototype node, after prototype is filled with data. **/
  Node newTimeEntryTable ; 

  // /** List of ID nodes in a cloned access tree. **/
  // Hashtable idnodesTimeEntryTable ; 


  /** ID DayDate1 from DB query on TimeEntryTable **/
  String fieldDayDate1 ; 

  /** ID TimeEntryId from DB query on TimeEntryTable **/
  String fieldTimeEntryId ; 

  /** ID DayDate from DB query on TimeEntryTable **/
  String fieldDayDate ; 

  /** ID ActivityId from DB query on TimeEntryTable **/
  String fieldActivityId ; 

  /** ID DayHeader from DB query on TimeEntryTable **/
  String fieldDayHeader ; 

  /** ID ProjectId from DB query on TimeEntryTable **/
  String fieldProjectId ; 

  /** ID Details from DB query on TimeEntryTable **/
  String fieldDetails ; 

  /** ID NrHours from DB query on TimeEntryTable **/
  String fieldNrHours ; 

  // End of database field declarations section. 


  /** 
   * Does the actual manipulation of the DOM data structure. 
   * 
   * It defines the abstract method in EditWorkItemsFormBASE.java.  
   * 
   * @exception ApplicationException
   * @exception HttpPresentationException
   **/
  public void manipulate() throws ApplicationException, HttpPresentationException {

    //////  Initialise
    bo = new EditWorkItemsFormBO( comms ); // Do not delete. May do user authentification, etc.
    //// Set DEBUG flag
    DEBUG = false ; 
    if( ProdUtil.nameInQueryString( args, "DEBUG" ) ) DEBUG = true ; 
    if( ProdUtil.sessionDebugFlag( debugData ) ) DEBUG = true ; 

    //////  Get values from query string 
    qs_noattr = ProdUtil.getFromQueryString( args, "_noattr" );
    qsToDate = ProdUtil.getFromQueryString( args, "ToDate" );
    qsFromDate = ProdUtil.getFromQueryString( args, "FromDate" );
    qsTimeEntryId = ProdUtil.getFromQueryString( args, "TimeEntryId" );
    qsEntryDate = ProdUtil.getFromQueryString( args, "EntryDate" );

    // DBG
    ProdUtil.log( "Query string pair: '_noattr' = '" + qs_noattr + "'" );
    ProdUtil.log( "Query string pair: 'ToDate' = '" + qsToDate + "'" );
    ProdUtil.log( "Query string pair: 'FromDate' = '" + qsFromDate + "'" );
    ProdUtil.log( "Query string pair: 'TimeEntryId' = '" + qsTimeEntryId + "'" );
    ProdUtil.log( "Query string pair: 'EntryDate' = '" + qsEntryDate + "'" );


    //////  Fill dynamic nodes
    //////  Processing records from DB query for ID TimeEntryTable
    countTimeEntryTable = bo.getTimeEntryTable( qsFromDate, qsToDate ); 
    if( countTimeEntryTable > 0 ){ 
      // DBG 
      ProdUtil.debug( "Query on TimeEntryTable returned " + countTimeEntryTable + " records." ); 

      for( iTimeEntryTable=0 ; iTimeEntryTable<countTimeEntryTable ; iTimeEntryTable++ ){
    
        ////////  Get field values from a TimeEntryTable record

        ////  In access TimeEntryTable, processing ID TimeEntryId
        // TimeEntryId uniquely identifies each record - get it first.
        fieldTimeEntryId = bo.getIdValue( iTimeEntryTable, "TimeEntryId", "" ); 
        fieldTimeEntryId = ProdUtil.cleanString( fieldTimeEntryId, false ); 
        protoTimeEntryId.setAttribute( "value", fieldTimeEntryId ); 

        ////  In access TimeEntryTable, processing ID DayDate1
        fieldDayDate1 = bo.getIdValue( iTimeEntryTable, "DayDate1", FormatUtil.DATE_LOCALE ); 
        fieldDayDate1 = ProdUtil.cleanString( fieldDayDate1, false ); 
        protoDayDate1.setAttribute( "value", fieldDayDate1 ); 

        ////  In access TimeEntryTable, processing ID DayDate
        fieldDayDate = bo.getIdValue( iTimeEntryTable, "DayDate", FormatUtil.DATE + "EEEE dd MMM yyyy" ); 
        fieldDayDate = ProdUtil.cleanString( fieldDayDate, true ); 
        XMLCUtil.getFirstText( protoDayDate ).setData( fieldDayDate ); 

        ////  In access TimeEntryTable, processing ID ActivityId
        fieldActivityId = bo.getIdValue( iTimeEntryTable, "ActivityId", "" ); 
        fieldActivityId = ProdUtil.cleanString( fieldActivityId, false ); 
        ProdUtil.drainSelect( protoActivityId, "ActivityId" ); 
        ProdUtil.fillSelect( protoActivityId, "ActivityId", bo.getPulldownItems( "ActivityId" ), fieldActivityId ); 
        protoActivityId.setAttribute( "name", "Activity_" + fieldTimeEntryId ); 

        ////  In access TimeEntryTable, processing ID DayHeader
        fieldDayHeader = bo.getIdValue( iTimeEntryTable, "DayHeader", "" ); 
        fieldDayHeader = ProdUtil.cleanString( fieldDayHeader, false ); 
        // NOTE: Config file indicates no value for node ID = DayHeader

        ////  In access TimeEntryTable, processing ID ProjectId
        fieldProjectId = bo.getIdValue( iTimeEntryTable, "ProjectId", "" ); 
        fieldProjectId = ProdUtil.cleanString( fieldProjectId, false ); 
        ProdUtil.drainSelect( protoProjectId, "ProjectId" ); 
        ProdUtil.fillSelect( protoProjectId, "ProjectId", bo.getPulldownItems( "ProjectId" ), fieldProjectId ); 
        protoProjectId.setAttribute( "name", "Project_" + fieldTimeEntryId ); 

        ////  In access TimeEntryTable, processing ID Details
        fieldDetails = bo.getIdValue( iTimeEntryTable, "Details", "" ); 
        fieldDetails = ProdUtil.cleanString( fieldDetails, false ); 
        XMLCUtil.getFirstText( protoDetails ).setData( fieldDetails ); 
        protoDetails.setAttribute( "name", "Details_" + fieldTimeEntryId ); 

        ////  In access TimeEntryTable, processing ID NrHours
        fieldNrHours = bo.getIdValue( iTimeEntryTable, "NrHours", "" ); 
        fieldNrHours = ProdUtil.cleanString( fieldNrHours, false ); 
        protoNrHours.setAttribute( "value", fieldNrHours ); 
        protoNrHours.setAttribute( "name", "Hours_" + fieldTimeEntryId ); 

        // DBG 
        ProdUtil.debug( "Filled access TimeEntryTable record #" + iTimeEntryTable ); 


        //////  Set up alternating CLASS attributes. 
        // NOTE: Mostly used for table rows when each is a DB record.
        ProdUtil.setClassAttributeModulo( protoTimeEntryTable, iTimeEntryTable ); 
        //////  Clone DOM node for TimeEntryTable record, and insert it.
        newTimeEntryTable = protoTimeEntryTable.cloneNode( true ); 
        // idnodesTimeEntryTable = ProdUtil.idHashtable( (HTMLElement) newTimeEntryTable ); 
        if( ProdUtil.stringHasContent( fieldDayHeader ) ){
          ProdUtil.insertSiblingBefore( protoDayHeader.cloneNode( true ), protoTimeEntryTable ); 
        }else{
        }
        ProdUtil.insertSiblingBefore( newTimeEntryTable, protoTimeEntryTable ); 
      }
    }else{
      // There were no TimeEntryTable records returned from DB    
      try{ 
        presentationData.set( "RESTOREQUERYSTRING", args );
      }catch( KeywordValueException kve ){
        throw new UserException( "No records were found matching your request." ); 
      }
      throw new UserException( "No records were found matching your request.", "EditWorkItemsQuery.po?RESTOREQUERYSTRING=TRUE" ); 
    }
    
    //////  Remove prototype from DOM  
    ProdUtil.removeThisNode( protoTimeEntryTable ); 
    ProdUtil.removeThisNode( protoDayHeader ); 

    //////  Processing ID DisplayFromDate
    XMLCUtil.getFirstText( protoDisplayFromDate ).setData( FormatUtil.format( FormatUtil.displayDateToSQL(qsFromDate, null), FormatUtil.DATE + "EEEE dd MMM yyyy" ) ); 

    //////  Processing ID ToDate
    protoToDate.setAttribute( "value", qsToDate ); 

    //////  Processing ID DisplayToDate
    XMLCUtil.getFirstText( protoDisplayToDate ).setData( FormatUtil.format(  FormatUtil.displayDateToSQL(qsToDate, null), FormatUtil.DATE + "EEEE dd MMM yyyy" ) ); 

    //////  Processing ID FromDate
    protoFromDate.setAttribute( "value", qsFromDate ); 

    //////  Restoring FORMS, if necessary
    if( ProdUtil.nameInQueryString( args, "RESTOREQUERYSTRING" ) ){ 
      ProdUtil.restoreFormsFromPresentationData( document, presentationData ); 
    }

    //////  Generate debugging information, if requested.
    if( DEBUG ){ 
      HTMLElement debugTemplate ; 
      //// Fill in debugging information
      debugTemplate = startDebugTemplate(); // Method is in BASE class.
      //// Insert debugging information into DOM tree.
      HTMLBodyElement bodyElement = ProdUtil.getBodyElement( document ); 
      bodyElement.insertBefore( debugTemplate, null ); 
    }
  }
}
