package timesheet.presentation.entry;

import java.util.*;
import org.w3c.dom.*;
import org.w3c.dom.html.*;
import com.lutris.util.*;
import com.lutris.xml.xmlc.*;
import com.lutris.appserver.server.ApplicationException;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.pisoftware.platypus.production.*; 
import timesheet.util.*; 
import timesheet.data.*; 
import timesheet.business.*; 
import timesheet.business.entry.*; 
import timesheet.presentation.*; 
import timesheet.presentation.entry.*; 

/** 
 * Class EditWorkItemsResultsBASE provides 
 * lots of methods and variables useful for manipulating the DOM data
 * structure created by class EditWorkItemsResultsHTML.
 * 
 * Generated by Platypus version 1.0.
 **/

public abstract class EditWorkItemsResultsBASE implements HttpPresentation {

  //////  Variable declarations

  /**  Business object which supports this presentation object **/
  EditWorkItemsResultsBO bo = null ; 
 
  /** Enhydra's DOM model for PO we're generating code for **/
  EditWorkItemsResultsHTML po ;
 
  /** DOM Document at root of presentation DOM data structure **/
  Document document ; 
 
  /** HttpPresentationComms object passed to run() **/
  HttpPresentationComms comms ; 
 
  /** Session data **/
  SessionData sessionData ;
 
  /** Section of session data reserved for presentation layer **/
  KeywordValueTable presentationData ;
 
  /** Section of session data reserved for debug flags. **/
  KeywordValueTable debugData ;
 
  /** Name value pairs from query string **/
  KeywordValueTable args ; 

  /** Unique id number for this invocation of the page. **/
  String servedId ; 

  /** Debugging flag **/
  boolean DEBUG ; 

  /** Variable to hold prototype SPAN node DayHours **/
  HTMLElement protoDayHours ; 

  /** Variable to hold prototype TD node DayDate **/
  HTMLTableCellElement protoDayDate ; 

  /** Variable to hold prototype SPAN node ProjectName **/
  HTMLElement protoProjectName ; 

  /** Variable to hold prototype TR node DayHeader **/
  HTMLTableRowElement protoDayHeader ; 

  /** Variable to hold prototype TR node TimeEntryTable **/
  HTMLTableRowElement protoTimeEntryTable ; 

  /** Variable to hold prototype SPAN node ActivityName **/
  HTMLElement protoActivityName ; 

  /** Variable to hold prototype SPAN node ToDate **/
  HTMLElement protoToDate ; 

  /** Variable to hold prototype SPAN node FromDate **/
  HTMLElement protoFromDate ; 

  /** Variable to hold prototype TD node Details **/
  HTMLTableCellElement protoDetails ; 

  /** Variable to hold prototype TD node NrHours **/
  HTMLTableCellElement protoNrHours ; 



  /** 
   * Does the actual manipulation of the DOM data structure. 
   * 
   * It is instantiated in the hand-crafted manipulation
   * class EditWorkItemsResultsBASE.java. 
   * 
   * @exception ApplicationException
   * @exception HttpPresentationException
   **/
  public abstract void manipulate() throws ApplicationException, HttpPresentationException ;


  /**
   * @exception HttpPresentationException
   **/
  // Uses variables like 'comms' and 'sessionData', so is in BASE class. Otherwise,
  // would belong in the ProdUtil class. One day, when stable, move to ProdUtil.
  HTMLElement startDebugTemplate() throws HttpPresentationException {
    AppTemplateHTML appTemplateHTML = new AppTemplateHTML(); 
    appTemplateHTML.setTextDebugQueryString( HttpUtil.getQueryFromRequest( comms.request ) ); 
    appTemplateHTML.setTextDebugSessionData( sessionData.toString() ); 
    return (HTMLElement) appTemplateHTML.getElementDebugTemplate(); 
  }


  /**
   * @exception HttpPresentationException
   **/
  public void run( HttpPresentationComms comms ) throws HttpPresentationException {

    //////  Initialise
    this.comms = comms ; 
    sessionData = comms.sessionData ;
    presentationData = ProdUtil.presentationData( sessionData ); 
    debugData = ProdUtil.ensureSectionData( "DEBUG", presentationData ); 
    po = new EditWorkItemsResultsHTML();
    document = po.getDocument();
    servedId = ProdUtil.getUniquePageString( presentationData ); 

    //////  Process query string 
    try{ 
      args = HttpUtil.buildQueryTable( HttpUtil.getQueryFromRequest( comms.request ) );
    }catch( KeywordValueException kve ){ 
      throw new HttpPresentationException( "Couldn't get CGI query string", kve );
    }
    
    //////  Initialise prototype variables
    protoDayHours = po.getElementDayHours(); 
    protoDayDate = po.getElementDayDate(); 
    protoProjectName = po.getElementProjectName(); 
    protoDayHeader = po.getElementDayHeader(); 
    protoTimeEntryTable = po.getElementTimeEntryTable(); 
    protoActivityName = po.getElementActivityName(); 
    protoToDate = po.getElementToDate(); 
    protoFromDate = po.getElementFromDate(); 
    protoDetails = po.getElementDetails(); 
    protoNrHours = po.getElementNrHours(); 

    //////  Let the hand-crafted code manipulate the DOM data structure
    try{
      manipulate(); 
    }catch( UserException ue ){
      AppTemplate.processUserException( document, ue ); 
    }catch( ApplicationException ae ){ 
      throw new HttpPresentationException( ae ); 
    }

    //////  Remove ID attributes from nodes
    ProdUtil.removeIDAttributes( document ); 

    //////  Write out manipulated DOM as HTML
    comms.response.writeHTML(po.toDocument());
  }
}
