package timesheet.business.maintenance;

import com.lutris.appserver.server.*;
import com.lutris.appserver.server.sql.*;
import com.lutris.appserver.server.httpPresentation.*;
import timesheet.*;
import timesheet.data.*;
import timesheet.business.*;
import java.util.*;
import com.lutris.dods.builder.sourceGenerators.Query.*;
import com.pisoftware.platypus.production.*;

/**
 * Date Created: Oct 15, 1999
 *<P>
 * Purpose: This class is a BO for the EditPersonList PO.  
 *
 */
public class EditPersonListBO extends MaintenanceBO {


/**
 * Constructor.  Creates the object, and initialises the appropriate variables, etc.
 *
 * @param comms  Used to get the session data required
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public EditPersonListBO(HttpPresentationComms comms) throws ApplicationException {

    super(comms);

  }
    
   
/**   
 * Returns the list of pulldown items for the name passed.
 *  
 * @param pulldown_name  The Pulldown name to query for
 * @return an array of PulldownDOs containing the list of values for this pulldown name, null or empty array if none found.
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */   
  public PulldownItem[] getPulldownItems(String pulldown_name) throws ApplicationException {

    /*
     * Add your code here if you want to override/add pulldown item(s).
     */
  
    return super.getPulldownItems(pulldown_name);

  }



/*
 * Start of Access Methods
*/



/**
 * getPersonTable: Query method for use by the PO layer.
 * 
 * @param qsFirstName Parameter supplied by PO
 * @param qsSurname Parameter supplied by PO
 * @param qsTitle Parameter supplied by PO
 * @param qsEmail Parameter supplied by PO
 * @param qsPhone Parameter supplied by PO
 * @param qsFax Parameter supplied by PO
 * @param qsType Parameter supplied by PO
 * @param qsUserName Parameter supplied by PO
 * @param qsCompanyId Parameter supplied by PO
 * @return The number of records found.
 * @exception ApplicationException All exceptions are caught and redirected to this.
 */
  public int getPersonTable(String qsFirstName, String qsSurname, String qsTitle, String qsEmail, String qsPhone, String qsFax, String qsType, String qsUserName, String qsCompanyId) throws ApplicationException {

    /*
     * Insert your code to do your query.  Put the result into
     * the variable PersonTable as defined above.  getIdValue
     * will use the PersonTable where appropriate.
     *
     */

    CompanyDO companyDO = null;

    // any company info?
    if (ProdUtil.stringHasContent(qsCompanyId)) {

      companyDO = companyBO.findCompany(qsCompanyId);

    }

    // DBG
    // System.err.println("FirstName: "+qsFirstName);
    // System.err.println("Surname: "+qsSurname);
    // System.err.println("Title: "+qsTitle);
    // System.err.println("Email: "+qsEmail);
    // System.err.println("Phone: "+qsPhone);
    // System.err.println("Fax: "+qsFax);
    // System.err.println("Type: "+qsType);
    // System.err.println("UserName: "+qsUserName);
    // System.err.println("CompanyId: "+qsCompanyId);

    PersonTable = personBO.getPerson(qsFirstName, qsSurname, qsTitle, qsEmail, qsPhone, qsFax, qsType, qsUserName, companyDO);
   
    // determine the number of records found
    return (PersonTable == null) ? 0 : PersonTable.length;  

  }



/*
 * End of Access Methods
*/



/*
  No Commit Method(s) Generated!
*/


/*
 * Start of getIdValue Methods
*/



/*
 * End of getIdValue Methods
*/



/*
  No getBusinessIdValue Method Generated!
*/

}

