package timesheet.presentation.entry;

import java.util.*;
// import java.net.URLEncoder;
import org.w3c.dom.*;
import org.w3c.dom.html.*;
import com.lutris.util.*;
import com.lutris.xml.xmlc.*;
import com.lutris.appserver.server.ApplicationException;
import com.lutris.appserver.server.sql.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.pisoftware.platypus.production.*;
import timesheet.presentation.*; 
import timesheet.presentation.entry.*; 
import timesheet.business.*; 
import timesheet.business.entry.*; 
import timesheet.data.*; 
import timesheet.util.*; 

/** 
 * Class AddOneItemForm manipulates the DOM
 * model created by class AddOneItemForm. 
 * 
 * TO DO: More detailed doco on what this class does.
 * 
 * Generated by Platypus version 1.0.
 **/

public class AddOneItemForm extends AddOneItemFormBASE{


  //////  Miscellaneous variables for presentation object
  // Query string and database variables are in a lower section.

  //////  Variables for the query string values
  ////  Form  'MainForm' in 'entry.AddOneItemQuery' PO invokes URL  'AddOneItemForm.po'

  /** Value of 'EntryDate' on query string, from MainForm form on addOneItemForm PO **/
  String qsEntryDate ; 

  /** Value of '_noattr' on query string, from MainForm form on addOneItemForm PO **/
  String qs_noattr ; 
  ////  Form  'MainForm' in 'entry.AddOneItemCommit' PO invokes URL  'AddOneItemForm.po'

  /** Value of 'TimeEntryId' on query string, from MainForm form on addOneItemForm PO **/
  String qsTimeEntryId ; 

  /** Value of 'ToDate' on query string, from MainForm form on addOneItemForm PO **/
  String qsToDate ; 

  /** Value of 'FromDate' on query string, from MainForm form on addOneItemForm PO **/
  String qsFromDate ; 

  //////  Variables for database query.

  //////  Declarations for DB query for TimeEntryTable

  /** Count of records returned by TimeEntryTable DB query. **/
  int countTimeEntryTable ;
  /** Loop index **/
  int iTimeEntryTable ; 

  /** Clone of prototype node, after prototype is filled with data. **/
  Node newTimeEntryTable ; 

  // /** List of ID nodes in a cloned access tree. **/
  // Hashtable idnodesTimeEntryTable ; 


  /** ID DayHours from DB query on TimeEntryTable **/
  String fieldDayHours ; 

  /** ID DayDate from DB query on TimeEntryTable **/
  String fieldDayDate ; 

  /** ID ProjectName from DB query on TimeEntryTable **/
  String fieldProjectName ; 

  /** ID ActivityName from DB query on TimeEntryTable **/
  String fieldActivityName ; 

  /** ID Details from DB query on TimeEntryTable **/
  String fieldDetails ; 

  /** ID NrHours from DB query on TimeEntryTable **/
  String fieldNrHours ; 

  // End of database field declarations section. 


  /** 
   * Does the actual manipulation of the DOM data structure. 
   * 
   * It defines the abstract method in AddOneItemFormBASE.java.  
   * 
   * @exception ApplicationException
   * @exception HttpPresentationException
   **/
  public void manipulate() throws ApplicationException, HttpPresentationException {

    //////  Initialise
    bo = new AddOneItemFormBO( comms ); // Do not delete. May do user authentification, etc.
    //// Set DEBUG flag
    DEBUG = false ; 
    if( ProdUtil.nameInQueryString( args, "DEBUG" ) ) DEBUG = true ; 
    if( ProdUtil.sessionDebugFlag( debugData ) ) DEBUG = true ; 

    //////  Get values from query string 
    qsEntryDate = ProdUtil.getFromQueryString( args, "EntryDate" );
    qs_noattr = ProdUtil.getFromQueryString( args, "_noattr" );
    qsTimeEntryId = ProdUtil.getFromQueryString( args, "TimeEntryId" );
    qsToDate = ProdUtil.getFromQueryString( args, "ToDate" );
    qsFromDate = ProdUtil.getFromQueryString( args, "FromDate" );
    // A null qsToDate or qsFromDate causes grief. Trust me on
    // this. URLEncode.encode( null ) seems to return two spaces,
    // which is neither empty, nor a legal date.
    qsToDate = ProdUtil.cleanString( qsToDate, "" ); 
    qsFromDate = ProdUtil.cleanString( qsFromDate, "" ); 

    // DBG
    ProdUtil.log( "Query string pair: 'EntryDate' = '" + qsEntryDate + "'" );
    ProdUtil.log( "Query string pair: '_noattr' = '" + qs_noattr + "'" );
    ProdUtil.log( "Query string pair: 'TimeEntryId' = '" + qsTimeEntryId + "'" );
    ProdUtil.log( "Query string pair: 'ToDate' = '" + qsToDate + "'" );
    ProdUtil.log( "Query string pair: 'FromDate' = '" + qsFromDate + "'" );


    //////  Fill dynamic nodes
    //////  Processing records from DB query for ID TimeEntryTable
    countTimeEntryTable = bo.getTimeEntryTable( qsEntryDate ); 
    if( countTimeEntryTable > 0 ){ 
      // DBG 
      ProdUtil.debug( "Query on TimeEntryTable returned " + countTimeEntryTable + " records." ); 

      for( iTimeEntryTable=0 ; iTimeEntryTable<countTimeEntryTable ; iTimeEntryTable++ ){
    
        ////////  Get field values from a TimeEntryTable record

        ////  In access TimeEntryTable, processing ID DayHours
        fieldDayHours = bo.getIdValue( iTimeEntryTable, "DayHours", "" ); 
        fieldDayHours = ProdUtil.cleanString( fieldDayHours, false ); 
        XMLCUtil.getFirstText( protoDayHours ).setData( fieldDayHours ); 

        ////  In access TimeEntryTable, processing ID DayDate
        fieldDayDate = bo.getIdValue( iTimeEntryTable, "DayDate", FormatUtil.DATE + "EEEE dd MMM yyyy" ); 
        fieldDayDate = ProdUtil.cleanString( fieldDayDate, false ); 
        XMLCUtil.getFirstText( protoDayDate ).setData( fieldDayDate ); 

        ////  In access TimeEntryTable, processing ID ProjectName
        fieldProjectName = bo.getIdValue( iTimeEntryTable, "ProjectName", "" ); 
        fieldProjectName = ProdUtil.cleanString( fieldProjectName, true ); 
        XMLCUtil.getFirstText( protoProjectName ).setData( fieldProjectName ); 

        ////  In access TimeEntryTable, processing ID ActivityName
        fieldActivityName = bo.getIdValue( iTimeEntryTable, "ActivityName", "" ); 
        fieldActivityName = ProdUtil.cleanString( fieldActivityName, true ); 
        XMLCUtil.getFirstText( protoActivityName ).setData( fieldActivityName ); 

        ////  In access TimeEntryTable, processing ID Details
        fieldDetails = bo.getIdValue( iTimeEntryTable, "Details", "" ); 
        fieldDetails = ProdUtil.cleanString( fieldDetails, true ); 
        XMLCUtil.getFirstText( protoDetails ).setData( fieldDetails ); 

        ////  In access TimeEntryTable, processing ID NrHours
        fieldNrHours = bo.getIdValue( iTimeEntryTable, "NrHours", "" ); 
        fieldNrHours = ProdUtil.cleanString( fieldNrHours, true ); 
        XMLCUtil.getFirstText( protoNrHours ).setData( fieldNrHours ); 

        // DBG 
        ProdUtil.debug( "Filled access TimeEntryTable record #" + iTimeEntryTable ); 


        //////  Set up alternating CLASS attributes. 
        // NOTE: Mostly used for table rows when each is a DB record.
        ProdUtil.setClassAttributeModulo( protoTimeEntryTable, iTimeEntryTable ); 
        //////  Clone DOM node for TimeEntryTable record, and insert it.
        newTimeEntryTable = protoTimeEntryTable.cloneNode( true ); 
        // idnodesTimeEntryTable = ProdUtil.idHashtable( (HTMLElement) newTimeEntryTable ); 
        ProdUtil.insertSiblingBefore( newTimeEntryTable, protoTimeEntryTable ); 
      }
    }else{
      // There were no TimeEntryTable records returned from DB
      // It doesn't matter if none were found - each new day starts empty!
      // But we had better handle the header and remove the table.

      ////  In access TimeEntryTable, processing ID DayHours
      fieldDayHours = "0" ; 
      XMLCUtil.getFirstText( protoDayHours ).setData( fieldDayHours ); 
      
      ////  In access TimeEntryTable, processing ID DayDate
      fieldDayDate = FormatUtil.format( FormatUtil.displayDateToSQL(qsEntryDate, null), FormatUtil.DATE + "EEEE dd MMM yyyy" ); 
      XMLCUtil.getFirstText( protoDayDate ).setData( fieldDayDate ); 

      ////  Remove whole table
      ProdUtil.removeThisNodeAndContext( protoTimeEntryTable, HTMLTableElement.class ); 
    }
    
    //////  Remove prototype from DOM  
    ProdUtil.removeThisNode( protoTimeEntryTable ); 

    //////  Processing ID EntryDate
    protoEntryDate.setAttribute( "value", qsEntryDate ); 

    //////  Processing ID ActivityId
    ProdUtil.drainSelect( protoActivityId, "ActivityId" ); 
    ProdUtil.fillSelect( protoActivityId, "ActivityId", bo.getPulldownItems( "ActivityId" ) ); 

    //////  Processing ID ToDate
    protoToDate.setAttribute( "value", qsToDate ); 

    //////  Processing ID ProjectId
    ProdUtil.drainSelect( protoProjectId, "ProjectId" ); 
    ProdUtil.fillSelect( protoProjectId, "ProjectId", bo.getPulldownItems( "ProjectId" ) ); 

    //////  Processing ID FromDate
    protoFromDate.setAttribute( "value", qsFromDate ); 

    //////  Restoring FORMS, if necessary
    if( ProdUtil.nameInQueryString( args, "RESTOREQUERYSTRING" ) ){ 
      ProdUtil.restoreFormsFromPresentationData( document, presentationData ); 
    }

    //////  Generate debugging information, if requested.
    if( DEBUG ){ 
      HTMLElement debugTemplate ; 
      //// Fill in debugging information
      debugTemplate = startDebugTemplate(); // Method is in BASE class.
      //// Insert debugging information into DOM tree.
      HTMLBodyElement bodyElement = ProdUtil.getBodyElement( document ); 
      bodyElement.insertBefore( debugTemplate, null ); 
    }
  }
}
