/* This SQL was generated for a PostgreSQL database. */

create table t_timeentry
(
/* class TimeEntry */
PersonId INT8   NOT NULL  REFERENCES t_person(objectID) ,
ActivityId INT8   NOT NULL  REFERENCES t_activity(objectID) ,
ProjectId INT8   NOT NULL  REFERENCES t_project(objectID) ,
EntryDate DATE   NOT NULL   ,
Details VARCHAR(255)      ,
NrHours FLOAT8 DEFAULT 0.0  NOT NULL   ,

    /* NOTICE: */
    /* This table represents a Data Object class  */
    /* derived from dods.builder.sourceGenerators.DO.GenericDO. */
    /* The class GenericDO contains: */
    /* 1) an ObjectId (objectID)     which is stored as a DECIMAL(19,0) */
    /* 2) an int      (objectVersion) which is stored as an INTEGER */
    /* When creating Data Objects in DODS, these two columns */
    /* (a.k.a class members, Data Object Attributes) */
    /* should never be defined explicitly. */

    /* These columns are defined here at the end of the */
    /* CREATE TABLE statement to simplify the handling of commas. */
    objectID INT8 NOT NULL PRIMARY KEY,
    objectVersion INT4 NOT NULL

);

CREATE INDEX I1_t_timeentry ON t_timeentry(PersonId);
CREATE INDEX I2_t_timeentry ON t_timeentry(ActivityId);
CREATE INDEX I3_t_timeentry ON t_timeentry(ProjectId);
CREATE INDEX I4_t_timeentry ON t_timeentry(EntryDate);

/* This SQL was generated for a PostgreSQL database. */

create table t_company
(
/* class Company */
Name VARCHAR(255)  UNIQUE NOT NULL   ,
PhysicalStreet VARCHAR(255)      ,
PhysicalCity VARCHAR(255)      ,
PhysicalPostCode VARCHAR(255)      ,
PhysicalState VARCHAR(255)      ,
PostalStreet VARCHAR(255)      ,
PostalCity VARCHAR(255)      ,
PostalPostCode VARCHAR(255)      ,
PostalState VARCHAR(255)      ,
Country VARCHAR(255)      ,
Phone VARCHAR(255)      ,
Fax VARCHAR(255)      ,
URL VARCHAR(255)      ,

    /* NOTICE: */
    /* This table represents a Data Object class  */
    /* derived from dods.builder.sourceGenerators.DO.GenericDO. */
    /* The class GenericDO contains: */
    /* 1) an ObjectId (objectID)     which is stored as a DECIMAL(19,0) */
    /* 2) an int      (objectVersion) which is stored as an INTEGER */
    /* When creating Data Objects in DODS, these two columns */
    /* (a.k.a class members, Data Object Attributes) */
    /* should never be defined explicitly. */

    /* These columns are defined here at the end of the */
    /* CREATE TABLE statement to simplify the handling of commas. */
    objectID INT8 NOT NULL PRIMARY KEY,
    objectVersion INT4 NOT NULL

);

CREATE INDEX I1_t_company ON t_company(Name);

/* This SQL was generated for a PostgreSQL database. */

create table t_project
(
/* class Project */
Name VARCHAR(255)  UNIQUE NOT NULL   ,
CompanyId INT8   NOT NULL  REFERENCES t_company(objectID) ,
Status VARCHAR(255) DEFAULT 'Active'  NOT NULL   ,
OutstandingWorkState BOOL DEFAULT true  NOT NULL   ,
DevelopmentURL VARCHAR(255)      ,
ProductionURL VARCHAR(255)      ,
CurrentVersion VARCHAR(255) DEFAULT 'Alpha 0.0'     ,
AdditionalContactDetails VARCHAR(255)      ,
DevelopmentDirectory VARCHAR(255)      ,
ProductionDirectory VARCHAR(255)      ,
SuppliedContentDirectory VARCHAR(255)      ,
BaseDirectory VARCHAR(255)      ,
PurchaseHistoryFile VARCHAR(255)      ,
Relationship VARCHAR(255)      ,
ServiceLevelAgreementFile VARCHAR(255)      ,
OutstandingWorkInformationFile VARCHAR(255)      ,
NotesFile VARCHAR(255)      ,

    /* NOTICE: */
    /* This table represents a Data Object class  */
    /* derived from dods.builder.sourceGenerators.DO.GenericDO. */
    /* The class GenericDO contains: */
    /* 1) an ObjectId (objectID)     which is stored as a DECIMAL(19,0) */
    /* 2) an int      (objectVersion) which is stored as an INTEGER */
    /* When creating Data Objects in DODS, these two columns */
    /* (a.k.a class members, Data Object Attributes) */
    /* should never be defined explicitly. */

    /* These columns are defined here at the end of the */
    /* CREATE TABLE statement to simplify the handling of commas. */
    objectID INT8 NOT NULL PRIMARY KEY,
    objectVersion INT4 NOT NULL

);

CREATE INDEX I1_t_project ON t_project(Name);
CREATE INDEX I2_t_project ON t_project(CompanyId);
CREATE INDEX I3_t_project ON t_project(Status);

/* This SQL was generated for a PostgreSQL database. */

create table t_person
(
/* class Person */
CompanyId INT8   NOT NULL  REFERENCES t_company(objectID) ,
FirstName VARCHAR(255)   NOT NULL   ,
Surname VARCHAR(255)   NOT NULL   ,
Title VARCHAR(255)      ,
Email VARCHAR(255)      ,
Phone VARCHAR(255)      ,
Fax VARCHAR(255)      ,
Type VARCHAR(255) DEFAULT 'customer'  NOT NULL   ,
AuthorisationLevel VARCHAR(255) DEFAULT 'none'  NOT NULL   ,
PublicPassword VARCHAR(255)      ,
UserName VARCHAR(255) DEFAULT 'none'  NOT NULL   ,

    /* NOTICE: */
    /* This table represents a Data Object class  */
    /* derived from dods.builder.sourceGenerators.DO.GenericDO. */
    /* The class GenericDO contains: */
    /* 1) an ObjectId (objectID)     which is stored as a DECIMAL(19,0) */
    /* 2) an int      (objectVersion) which is stored as an INTEGER */
    /* When creating Data Objects in DODS, these two columns */
    /* (a.k.a class members, Data Object Attributes) */
    /* should never be defined explicitly. */

    /* These columns are defined here at the end of the */
    /* CREATE TABLE statement to simplify the handling of commas. */
    objectID INT8 NOT NULL PRIMARY KEY,
    objectVersion INT4 NOT NULL

);

CREATE INDEX I1_t_person ON t_person(CompanyId);
CREATE INDEX I2_t_person ON t_person(Surname);
CREATE INDEX I3_t_person ON t_person(Type);
CREATE INDEX I4_t_person ON t_person(UserName);

/* This SQL was generated for a PostgreSQL database. */

create table t_activity
(
/* class Activity */
ActivityName VARCHAR(255)  UNIQUE NOT NULL   ,
UseByContractors BOOL DEFAULT true  NOT NULL   ,

    /* NOTICE: */
    /* This table represents a Data Object class  */
    /* derived from dods.builder.sourceGenerators.DO.GenericDO. */
    /* The class GenericDO contains: */
    /* 1) an ObjectId (objectID)     which is stored as a DECIMAL(19,0) */
    /* 2) an int      (objectVersion) which is stored as an INTEGER */
    /* When creating Data Objects in DODS, these two columns */
    /* (a.k.a class members, Data Object Attributes) */
    /* should never be defined explicitly. */

    /* These columns are defined here at the end of the */
    /* CREATE TABLE statement to simplify the handling of commas. */
    objectID INT8 NOT NULL PRIMARY KEY,
    objectVersion INT4 NOT NULL

);

CREATE INDEX I1_t_activity ON t_activity(ActivityName);

create table objectid(
 next INT8 NOT NULL 
);
