/* This SQL was generated for a PostgreSQL database. */

create table t_timeentry
(
/* class TimeEntry */
PersonId INT8   NOT NULL  REFERENCES t_person(objectID) ,
ActivityId INT8   NOT NULL  REFERENCES t_activity(objectID) ,
ProjectId INT8   NOT NULL  REFERENCES t_project(objectID) ,
EntryDate DATE   NOT NULL   ,
Details VARCHAR(255)      ,
NrHours FLOAT8 DEFAULT 0.0  NOT NULL   ,

    /* NOTICE: */
    /* This table represents a Data Object class  */
    /* derived from dods.builder.sourceGenerators.DO.GenericDO. */
    /* The class GenericDO contains: */
    /* 1) an ObjectId (objectID)     which is stored as a DECIMAL(19,0) */
    /* 2) an int      (objectVersion) which is stored as an INTEGER */
    /* When creating Data Objects in DODS, these two columns */
    /* (a.k.a class members, Data Object Attributes) */
    /* should never be defined explicitly. */

    /* These columns are defined here at the end of the */
    /* CREATE TABLE statement to simplify the handling of commas. */
    objectID INT8 NOT NULL PRIMARY KEY,
    objectVersion INT4 NOT NULL

);

CREATE INDEX I1_t_timeentry ON t_timeentry(PersonId);
CREATE INDEX I2_t_timeentry ON t_timeentry(ActivityId);
CREATE INDEX I3_t_timeentry ON t_timeentry(ProjectId);
CREATE INDEX I4_t_timeentry ON t_timeentry(EntryDate);

