package timesheet.presentation;

import java.util.*;
import org.w3c.dom.*;
import org.w3c.dom.html.*;
import com.lutris.util.*;
import com.lutris.xml.xmlc.*;
import com.lutris.appserver.server.ApplicationException;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.pisoftware.platypus.production.*; 
import timesheet.util.*; 
import timesheet.data.*; 
import timesheet.business.*; 
import timesheet.business.*; 
import timesheet.presentation.*; 
import timesheet.presentation.*; 

/** 
 * Class NavBarBASE provides 
 * lots of methods and variables useful for manipulating the DOM data
 * structure created by class NavBarHTML.
 * 
 * Generated by Platypus version 1.0.
 **/

public abstract class NavBarBASE implements HttpPresentation {

  //////  Variable declarations

  /**  Business object which supports this presentation object **/
  NavBarBO bo = null ; 
 
  /** Enhydra's DOM model for PO we're generating code for **/
  NavBarHTML po ;
 
  /** DOM Document at root of presentation DOM data structure **/
  Document document ; 
 
  /** HttpPresentationComms object passed to run() **/
  HttpPresentationComms comms ; 
 
  /** Session data **/
  SessionData sessionData ;
 
  /** Section of session data reserved for presentation layer **/
  KeywordValueTable presentationData ;
 
  /** Section of session data reserved for debug flags. **/
  KeywordValueTable debugData ;
 
  /** Name value pairs from query string **/
  KeywordValueTable args ; 

  /** Unique id number for this invocation of the page. **/
  String servedId ; 

  /** Debugging flag **/
  boolean DEBUG ; 



  /** 
   * Does the actual manipulation of the DOM data structure. 
   * 
   * It is instantiated in the hand-crafted manipulation
   * class NavBarBASE.java. 
   * 
   * @exception ApplicationException
   * @exception HttpPresentationException
   **/
  public abstract void manipulate() throws ApplicationException, HttpPresentationException ;


  /**
   * @exception HttpPresentationException
   **/
  // Uses variables like 'comms' and 'sessionData', so is in BASE class. Otherwise,
  // would belong in the ProdUtil class. One day, when stable, move to ProdUtil.
  HTMLElement startDebugTemplate() throws HttpPresentationException {
    AppTemplateHTML appTemplateHTML = new AppTemplateHTML(); 
    appTemplateHTML.setTextDebugQueryString( HttpUtil.getQueryFromRequest( comms.request ) ); 
    appTemplateHTML.setTextDebugSessionData( sessionData.toString() ); 
    return (HTMLElement) appTemplateHTML.getElementDebugTemplate(); 
  }


  /**
   * @exception HttpPresentationException
   **/
  public void run( HttpPresentationComms comms ) throws HttpPresentationException {

    //////  Initialise
    this.comms = comms ; 
    sessionData = comms.sessionData ;
    presentationData = ProdUtil.presentationData( sessionData ); 
    debugData = ProdUtil.ensureSectionData( "DEBUG", presentationData ); 
    po = new NavBarHTML();
    document = po.getDocument();
    servedId = ProdUtil.getUniquePageString( presentationData ); 

    //////  Process query string 
    try{ 
      args = HttpUtil.buildQueryTable( HttpUtil.getQueryFromRequest( comms.request ) );
    }catch( KeywordValueException kve ){ 
      throw new HttpPresentationException( "Couldn't get CGI query string", kve );
    }
    
    //////  Initialise prototype variables

    //////  Let the hand-crafted code manipulate the DOM data structure
    try{
      manipulate(); 
    }catch( UserException ue ){
      AppTemplate.processUserException( document, ue ); 
    }catch( ApplicationException ae ){ 
      throw new HttpPresentationException( ae ); 
    }

    //////  Remove ID attributes from nodes
    ProdUtil.removeIDAttributes( document ); 

    //////  Write out manipulated DOM as HTML
    comms.response.writeHTML(po.toDocument());
  }
}
