package timesheet.presentation.maintenance;

import java.util.*;
import org.w3c.dom.*;
import org.w3c.dom.html.*;
import com.lutris.util.*;
import com.lutris.xml.xmlc.*;
import com.lutris.appserver.server.ApplicationException;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.pisoftware.platypus.production.*; 
import timesheet.util.*; 
import timesheet.data.*; 
import timesheet.business.*; 
import timesheet.business.maintenance.*; 
import timesheet.presentation.*; 
import timesheet.presentation.maintenance.*; 

/** 
 * Class EditPersonListBASE provides 
 * lots of methods and variables useful for manipulating the DOM data
 * structure created by class EditPersonListHTML.
 * 
 * Generated by Platypus version 1.0.
 **/

public abstract class EditPersonListBASE implements HttpPresentation {

  //////  Variable declarations

  /**  Business object which supports this presentation object **/
  EditPersonListBO bo = null ; 
 
  /** Enhydra's DOM model for PO we're generating code for **/
  EditPersonListHTML po ;
 
  /** DOM Document at root of presentation DOM data structure **/
  Document document ; 
 
  /** HttpPresentationComms object passed to run() **/
  HttpPresentationComms comms ; 
 
  /** Session data **/
  SessionData sessionData ;
 
  /** Section of session data reserved for presentation layer **/
  KeywordValueTable presentationData ;
 
  /** Section of session data reserved for debug flags. **/
  KeywordValueTable debugData ;
 
  /** Name value pairs from query string **/
  KeywordValueTable args ; 

  /** Unique id number for this invocation of the page. **/
  String servedId ; 

  /** Debugging flag **/
  boolean DEBUG ; 

  /** Variable to hold prototype TR node PersonTable **/
  HTMLTableRowElement protoPersonTable ; 

  /** Variable to hold prototype TD node FirstName **/
  HTMLTableCellElement protoFirstName ; 

  /** Variable to hold prototype TD node AuthorisationLevel **/
  HTMLTableCellElement protoAuthorisationLevel ; 

  /** Variable to hold prototype TD node Title **/
  HTMLTableCellElement protoTitle ; 

  /** Variable to hold prototype TD node Phone **/
  HTMLTableCellElement protoPhone ; 

  /** Variable to hold prototype A node ObjectId **/
  HTMLAnchorElement protoObjectId ; 

  /** Variable to hold prototype TD node Surname **/
  HTMLTableCellElement protoSurname ; 

  /** Variable to hold prototype TD node Type **/
  HTMLTableCellElement protoType ; 

  /** Variable to hold prototype TD node UserName **/
  HTMLTableCellElement protoUserName ; 

  /** Variable to hold prototype TD node Email **/
  HTMLTableCellElement protoEmail ; 

  /** Variable to hold prototype TD node CompanyName **/
  HTMLTableCellElement protoCompanyName ; 

  /** Variable to hold prototype TD node Fax **/
  HTMLTableCellElement protoFax ; 



  /** 
   * Does the actual manipulation of the DOM data structure. 
   * 
   * It is instantiated in the hand-crafted manipulation
   * class EditPersonListBASE.java. 
   * 
   * @exception ApplicationException
   * @exception HttpPresentationException
   **/
  public abstract void manipulate() throws ApplicationException, HttpPresentationException ;


  /**
   * @exception HttpPresentationException
   **/
  // Uses variables like 'comms' and 'sessionData', so is in BASE class. Otherwise,
  // would belong in the ProdUtil class. One day, when stable, move to ProdUtil.
  HTMLElement startDebugTemplate() throws HttpPresentationException {
    AppTemplateHTML appTemplateHTML = new AppTemplateHTML(); 
    appTemplateHTML.setTextDebugQueryString( HttpUtil.getQueryFromRequest( comms.request ) ); 
    appTemplateHTML.setTextDebugSessionData( sessionData.toString() ); 
    return (HTMLElement) appTemplateHTML.getElementDebugTemplate(); 
  }


  /**
   * @exception HttpPresentationException
   **/
  public void run( HttpPresentationComms comms ) throws HttpPresentationException {

    //////  Initialise
    this.comms = comms ; 
    sessionData = comms.sessionData ;
    presentationData = ProdUtil.presentationData( sessionData ); 
    debugData = ProdUtil.ensureSectionData( "DEBUG", presentationData ); 
    po = new EditPersonListHTML();
    document = po.getDocument();
    servedId = ProdUtil.getUniquePageString( presentationData ); 

    //////  Process query string 
    try{ 
      args = HttpUtil.buildQueryTable( HttpUtil.getQueryFromRequest( comms.request ) );
    }catch( KeywordValueException kve ){ 
      throw new HttpPresentationException( "Couldn't get CGI query string", kve );
    }
    
    //////  Initialise prototype variables
    protoPersonTable = po.getElementPersonTable(); 
    protoFirstName = po.getElementFirstName(); 
    protoAuthorisationLevel = po.getElementAuthorisationLevel(); 
    protoTitle = po.getElementTitle(); 
    protoPhone = po.getElementPhone(); 
    protoObjectId = po.getElementObjectId(); 
    protoSurname = po.getElementSurname(); 
    protoType = po.getElementType(); 
    protoUserName = po.getElementUserName(); 
    protoEmail = po.getElementEmail(); 
    protoCompanyName = po.getElementCompanyName(); 
    protoFax = po.getElementFax(); 

    //////  Let the hand-crafted code manipulate the DOM data structure
    try{
      manipulate(); 
    }catch( UserException ue ){
      AppTemplate.processUserException( document, ue ); 
    }catch( ApplicationException ae ){ 
      throw new HttpPresentationException( ae ); 
    }

    //////  Remove ID attributes from nodes
    ProdUtil.removeIDAttributes( document ); 

    //////  Write out manipulated DOM as HTML
    comms.response.writeHTML(po.toDocument());
  }
}
