package timesheet.presentation.reports;

import java.util.*;
// import java.net.URLEncoder;
import org.w3c.dom.*;
import org.w3c.dom.html.*;
import com.lutris.util.*;
import com.lutris.xml.xmlc.*;
import com.lutris.appserver.server.ApplicationException;
import com.lutris.appserver.server.sql.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.pisoftware.platypus.production.*;
import timesheet.presentation.*; 
import timesheet.presentation.reports.*; 
import timesheet.business.*; 
import timesheet.business.reports.*; 
import timesheet.data.*; 
import timesheet.util.*; 

/** 
 * Class ReportPeriodResults manipulates the DOM
 * model created by class ReportPeriodResults. 
 * 
 * TO DO: More detailed doco on what this class does.
 * 
 * Generated by Platypus version 1.0.
 **/

public class ReportPeriodResults extends ReportPeriodResultsBASE{


  //////  Miscellaneous variables for presentation object
  // Query string and database variables are in a lower section.

  //////  Variables for the query string values
  ////  Form  'MainForm' in 'reports.ReportPeriodQuery' PO invokes URL  'ReportPeriodResults.po'

  /** Value of '_noattr' on query string, from MainForm form on reportPeriodResults PO **/
  String qs_noattr ; 

  /** Value of 'ToDate' on query string, from MainForm form on reportPeriodResults PO **/
  String qsToDate ; 

  /** Value of 'FromDate' on query string, from MainForm form on reportPeriodResults PO **/
  String qsFromDate ; 

  //////  Variables for database query.

  //////  Declarations for DB query for TimeEntryTable

  /** Count of records returned by TimeEntryTable DB query. **/
  int countTimeEntryTable ;
  /** Loop index **/
  int iTimeEntryTable ; 

  /** Clone of prototype node, after prototype is filled with data. **/
  Node newTimeEntryTable ; 

  // /** List of ID nodes in a cloned access tree. **/
  // Hashtable idnodesTimeEntryTable ; 


  /** ID DayHours from DB query on TimeEntryTable **/
  String fieldDayHours ; 

  /** ID DayDate from DB query on TimeEntryTable **/
  String fieldDayDate ; 

  /** ID ProjectName from DB query on TimeEntryTable **/
  String fieldProjectName ; 

  /** ID DayHeader from DB query on TimeEntryTable **/
  String fieldDayHeader ; 

  /** ID ActivityName from DB query on TimeEntryTable **/
  String fieldActivityName ; 

  /** ID Details from DB query on TimeEntryTable **/
  String fieldDetails ; 

  /** ID NrHours from DB query on TimeEntryTable **/
  String fieldNrHours ; 

  // End of database field declarations section. 


  /** 
   * Does the actual manipulation of the DOM data structure. 
   * 
   * It defines the abstract method in ReportPeriodResultsBASE.java.  
   * 
   * @exception ApplicationException
   * @exception HttpPresentationException
   **/
  public void manipulate() throws ApplicationException, HttpPresentationException {

    //////  Initialise
    bo = new ReportPeriodResultsBO( comms ); // Do not delete. May do user authentification, etc.
    //// Set DEBUG flag
    DEBUG = false ; 
    if( ProdUtil.nameInQueryString( args, "DEBUG" ) ) DEBUG = true ; 
    if( ProdUtil.sessionDebugFlag( debugData ) ) DEBUG = true ; 

    //////  Get values from query string 
    qs_noattr = ProdUtil.getFromQueryString( args, "_noattr" );
    qsToDate = ProdUtil.getFromQueryString( args, "ToDate" );
    qsFromDate = ProdUtil.getFromQueryString( args, "FromDate" );

    // DBG
    ProdUtil.log( "Query string pair: '_noattr' = '" + qs_noattr + "'" );
    ProdUtil.log( "Query string pair: 'ToDate' = '" + qsToDate + "'" );
    ProdUtil.log( "Query string pair: 'FromDate' = '" + qsFromDate + "'" );


    //////  Fill dynamic nodes
    //////  Processing records from DB query for ID TimeEntryTable
    countTimeEntryTable = bo.getTimeEntryTable( qsFromDate, qsToDate ); 
    if( countTimeEntryTable > 0 ){ 
      // DBG 
      ProdUtil.debug( "Query on TimeEntryTable returned " + countTimeEntryTable + " records." ); 

      for( iTimeEntryTable=0 ; iTimeEntryTable<countTimeEntryTable ; iTimeEntryTable++ ){
    
        ////////  Get field values from a TimeEntryTable record

        ////  In access TimeEntryTable, processing ID DayHours
        fieldDayHours = bo.getIdValue( iTimeEntryTable, "DayHours", "" ); 
        fieldDayHours = ProdUtil.cleanString( fieldDayHours, true ); 
        XMLCUtil.getFirstText( protoDayHours ).setData( fieldDayHours ); 

        ////  In access TimeEntryTable, processing ID DayDate
        fieldDayDate = bo.getIdValue( iTimeEntryTable, "DayDate", FormatUtil.DATE + "EEEE dd MMM yyyy" ); 
        fieldDayDate = ProdUtil.cleanString( fieldDayDate, true ); 
        XMLCUtil.getFirstText( protoDayDate ).setData( fieldDayDate ); 

        ////  In access TimeEntryTable, processing ID ProjectName
        fieldProjectName = bo.getIdValue( iTimeEntryTable, "ProjectName", "" ); 
        fieldProjectName = ProdUtil.cleanString( fieldProjectName, true ); 
        XMLCUtil.getFirstText( protoProjectName ).setData( fieldProjectName ); 

        ////  In access TimeEntryTable, processing ID DayHeader
        fieldDayHeader = bo.getIdValue( iTimeEntryTable, "DayHeader", "" ); 
        fieldDayHeader = ProdUtil.cleanString( fieldDayHeader, false ); 
        // NOTE: Config file indicates no value for node ID = DayHeader

        ////  In access TimeEntryTable, processing ID ActivityName
        fieldActivityName = bo.getIdValue( iTimeEntryTable, "ActivityName", "" ); 
        fieldActivityName = ProdUtil.cleanString( fieldActivityName, true ); 
        XMLCUtil.getFirstText( protoActivityName ).setData( fieldActivityName ); 

        ////  In access TimeEntryTable, processing ID Details
        fieldDetails = bo.getIdValue( iTimeEntryTable, "Details", "" ); 
        fieldDetails = ProdUtil.cleanString( fieldDetails, true ); 
        XMLCUtil.getFirstText( protoDetails ).setData( fieldDetails ); 

        ////  In access TimeEntryTable, processing ID NrHours
        fieldNrHours = bo.getIdValue( iTimeEntryTable, "NrHours", "" ); 
        fieldNrHours = ProdUtil.cleanString( fieldNrHours, true ); 
        XMLCUtil.getFirstText( protoNrHours ).setData( fieldNrHours ); 

        // DBG 
        ProdUtil.debug( "Filled access TimeEntryTable record #" + iTimeEntryTable ); 


        //////  Set up alternating CLASS attributes. 
        // NOTE: Mostly used for table rows when each is a DB record.
        ProdUtil.setClassAttributeModulo( protoTimeEntryTable, iTimeEntryTable ); 
        //////  Clone DOM node for TimeEntryTable record, and insert it.
        newTimeEntryTable = protoTimeEntryTable.cloneNode( true ); 
        // idnodesTimeEntryTable = ProdUtil.idHashtable( (HTMLElement) newTimeEntryTable ); 
        // TODO: Code for getting values (if any) - move from inside the 'then' clause to before the 'if()'.
        // TODO: Check the if() condition! Perhaps ( bo.isIdValue( "DayHeader" ) )?
        if( ProdUtil.stringHasContent( fieldDayHeader ) ){
        }else{
          ProdUtil.removeThisNode( (Node)(idnodesTimeEntryTable.get( "DayHeader" )) ); 
        }
        ProdUtil.insertSiblingBefore( newTimeEntryTable, protoTimeEntryTable ); 
      }
    }else{
      // There were no TimeEntryTable records returned from DB
      // TODO: Check value for PO with query form (2nd arg below), eg "reports/SalesDate"
      throw new UserException( "No records were found matching your request.", "reports/ReportPeriodQuery" ); 
    }
    
    //////  Remove prototype from DOM  
    ProdUtil.removeThisNode( protoTimeEntryTable ); 

    //////  Processing ID ToDate
    XMLCUtil.getFirstText( protoToDate ).setData( qsToDate ); 

    //////  Processing ID FromDate
    XMLCUtil.getFirstText( protoFromDate ).setData( qsFromDate ); 

    //////  Restoring FORMS, if necessary
    if( ProdUtil.nameInQueryString( args, "RESTOREQUERYSTRING" ) ){ 
      ProdUtil.restoreFormsFromPresentationData( document, presentationData ); 
    }

    //////  Generate debugging information, if requested.
    if( DEBUG ){ 
      HTMLElement debugTemplate ; 
      //// Fill in debugging information
      debugTemplate = startDebugTemplate(); // Method is in BASE class.
      //// Insert debugging information into DOM tree.
      HTMLBodyElement bodyElement = ProdUtil.getBodyElement( document ); 
      bodyElement.insertBefore( debugTemplate, null ); 
    }
  }
}
